<?PHP
/**
* \file enregistrer_particularites.php
* \ingroup Réglisse
* version  stable
*/
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"> 
<head>
<meta http-equiv="content-type" 
		content="text/html;charset=utf-8" />
	<title>Réglisse enregistrement des particularités</title>
	<meta name="author" content="Billard" />
	<meta name ="keywords" content ="education, distribution of students into several classes" />
	<link rel="stylesheet" type="text/css" href="styles.css" media="screen" />


<!--
	/////////  GPL Licence - Réglisse
	
	Copyright (c) 2011, Michel Billard Sirakawa http://sibylle.ouvaton.org
 
	This file is part of Réglisse.

	Réglisse is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	Date: 15 juin 2011
	Version :Réglisse version 1
	Author : Michel Billard Sirakawa BillardMchl (at) aol (point) com
	Information site : http://sibylle.ouvaton.org
	///////////
	
	-->
	
</head>
<!-- Enregistrement des particularités-->
<body style = 'width:98%;background-color:lavender'>
<?PHP
error_reporting(E_ALL);
include ("reglisse.inc");
$nb_individus = isset($_POST['nb_individus']) ? $_POST['nb_individus'] : 0;

/*========================================================================*/
/** 
*/
	$base = $_POST['base'];
	$passe = $_POST['passe'];	
class MyDB extends SQLite3
{
	function __construct($base, $passe)
	{
		try 
		{
			$this->open($base, SQLITE3_OPEN_READWRITE, $passe);
		}
		catch (Exception $e)
		{
			$this->open($base, SQLITE3_OPEN_CREATE, $passe);
		}
	}
}

/** 
	* Consultation des tables compatibles et incompatibles pour
	* identifier ceux pour qui des affinités ont déjà été saisies.
	*/
	$db = new MyDB($base, $passe);

	$chaine = "<div class = 'ligne_absolue' style = 'border:none'>".T_TITRE_1."";
	$requete = "delete from `compatibles`";
		$db->exec ($requete);
		/**
		* Enregistrement des rapprochements souhaités
		*/
		$regroupements = isset($_POST['rapprocher']) ? $_POST['rapprocher']: array();
		/** pour chaque individu pour lequel on a déclaré des particularités */
		foreach ($regroupements as $groupement)
		{
			/** int l'identificateur de l'individu tête de liste*/
			$id = $groupement[1];
			/** pour chacun des rapprochements possibles*/
			for ($i =2; $i<=6;$i++):
				/** int conversion de la saisie en entier */
				$valeur = intval($groupement[$i]);
				/** vérification de validité*/
				if  (is_int($valeur) and ($valeur>0 )and ($valeur <= $nb_individus)):
					$requete_controle = "select * from `compatibles` where (eleve_id_1 = $valeur)";
					$existant= $db->query ($requete_controle);
					$nb_cas = 0;
					while ($bidon = $existant->fetchArray()):
						$nb_cas ++;
					endwhile;
					if ($nb_cas == 0):
						$requete = "insert into `compatibles` (eleve_id_1, eleve_id_2) values ($id, $valeur)";
						$db->exec ($requete);
					endif;
				endif;
			endfor;
		}

		/**
		* Enregistrement des rapprochements à éviter
		*/		
		$requete = "delete from `incompatibles`";
		$db->exec ($requete);
		$separations = isset($_POST['separer']) ? $_POST['separer']: array();
		/** pour chaque individu pour lequel on a déclaré des particularités */
		foreach ($separations as $separation)
		{
			/** int l'identificateur de l'individu tête de liste*/
			$id = $separation[1];
			/** pour chacun des rapprochements à éviter*/
			for ($i =2; $i<=6;$i++):
				/** int conversion de la saisie en entier */
				$valeur = intval($separation[$i]);
				/** vérification de validité*/
				if  (is_int($valeur) and ($valeur>0 )and ($valeur <= $nb_individus)):
					$requete = "insert into `incompatibles` (eleve_id_1, eleve_id_2) values ($id, $valeur)";
					$db->exec ($requete);
					$requete = "insert into `Incompatibles` (eleve_id_2, eleve_id_1) values ($id, $valeur)";
					$db->exec ($requete);

				endif;
			
			endfor;
		}
		/**
		* Traitement des cas particuliers 
		*/
		$requete = "delete from `particuliers`";
		$db->exec ($requete);		
		$grouper = isset($_POST['grouper']) ? $_POST['grouper'] : array();
		foreach ($grouper as $ligne)
		{
			/** 
			la valeur attendue est numéro d'identificateur |-numéro d'identificateur|0
			si elle est positive c'est un des élèves à mettre dans la même classe
			si elle est négative c'est un des élèves à disperser
			*/
			$statut = $ligne;
			$id = abs($statut);
			if ($statut != 0):
				if ($statut >0):
					$cas = 1;
				else:
					$cas = 2;
				endif;
					$requete = "insert into `particuliers` (`eleve_id`, `eleve_cas`) values($id, $cas);";
					$db->exec ($requete);
			endif;	
		}
		

$chaine .="</div>
<div class = 'ligne_absolue' style='top:20%; left:0%;border:none'>
	<div class = 'cellule' style ='border: medium black inset '>
		<form method = 'post' action = 'menu_general.php'>
			<input type = 'hidden' name= 'nb_individus' value = '$nb_individus' />
			<input type = 'hidden' name= 'base' value = '$base' />
			<input type = 'hidden' name= 'passe' value = '$passe' />
			<button type = 'submit'>".
			T_RETOUR_MENU."</button>
		</form>
	</div>
	<div class = 'cellule' style ='border: medium black inset; text-align:right '>
		<form method = 'post' action = 'repartir_avec_particularites.php'>
			<input type = 'hidden' name= 'nb_individus' value = '$nb_individus' />
			<input type = 'hidden' name= 'base' value = '$base' />
			<input type = 'hidden' name= 'passe' value = '$passe' />
			".I_NB."<br><button type=' submit'>".
			T_REPARTIR_AVEC."</button>
		</form>
	</div>
</div>
	
	";
print "$chaine $bas_de_page";
?>
</body>
</html>