<?PHP
/**
* \file identifier_separateur.php
* \ingroup Réglisse
* \brief identification du délimiteur et du séparateur 
* \version  stable
* \details le chemin du fichier de cas est exact et le fichier lisible,
* la première ligne est lue, et on propose comme délimiteur celui qui 
* identifie le bon nombre de colonnes, et comme séparateur on laisse le choix 
* à l'utilisateur
* \param $nom_fichier : nom_fichier_recopie : le chemin d'origine saisi dans controler.php
* \param $base : base : le nom de la base de données passé par controler.php
* \param $passe : passe : le mot de passe de la base de données passé par controler.php

*/
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"> 
<head>
<meta http-equiv="content-type" 
		content="text/html;charset=utf-8" />
	<title>Réglisse identification du délimiteur et du séparateur</title>
	<meta name="author" content="Billard" />
	<meta name ="keywords" content ="education, distribution of students into several classes" />
	<link rel="stylesheet" type="text/css" href="styles.css" media="screen" />

<!--
	/GPL Licence - Réglisse
	
	Copyright (c) 2011, Michel Billard Sirakawa http://sibylle.ouvaton.org
 
	This file is part of Réglisse.

	Réglisse is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	Date: 15 juin 2011
	Version : 1
	Author : Michel Billard Sirakawa BillardMchl (at) aol (point) com
	Information site : http://sibylle.ouvaton.org
	///////////
	
	-->
	<style type="text/css">
/*<![CDATA[*/
 body.c8 {background-color:lavender}
 div.c7 {position:absolute;top:98%;left:35%;border:none;font-size:8pt; text-align:center}
 div.c6 {top:93%; right:10%; border:none}
 div.c5 {top:10%;height:80%;border-style:inset; overflow:scroll}
 div.c4 {border:none; margin-top: 0.2em}
 div.c3 {border:none}
 div.c2 {border:solid thin black;}
 div.c1 {top:0%; left:0%; border:none}
/*]]>*/
</style>

</head>
<!-- 
==========================================================================
			Cr&eacute;ation de la base de donn&eacute;es et des tables adapt&eacute;es 
-->
<?PHP
error_reporting(0);
include ("reglisse.inc");
/** string le nom attribué par le système au fichier temporaire créé */
$nom_temp = isset ($_FILES['nom_fic']['tmp_name']) ?$_FILES['nom_fic']['tmp_name']: "" ;
/** string nom d'origine du fichier */
$nom_fichier = $_POST['nom_fichier_recopie'];
$nom_login = $_POST['nom_login'];
/** boolean*/
$succes = move_uploaded_file($nom_temp, $nom_fichier);
/** string nom de la base de données*/
$base =  isset( $_POST['base']) ? $_POST['base'] : "";
/** string mot de passe de la base de données*/
$passe =  isset( $_POST['passe']) ? $_POST['passe'] : "";	
if (!$succes): //_________________________ nom de fichier vide
	$chaine  = T_TITRE_1."
	<div class = 'ligne_absolue' style ='top:10%; '>".T_PROBLEME_TRANSFERT."$nom_fichier
		<form method = 'post' action = 'supprimer.php'>
			<input type ='hidden' name = 'base' value = '$base' />
			<input type ='hidden' name = 'passe' value = '$passe' />					
			<button type = 'submit'>".T_REESSAYER."</button>
		</form>
	</div>";
else: //_________________________________________nom de fichier existant
	$fic = fopen($nom_fichier, "r");
	//___________________________________________fichier ouvert
	/** string une ligne du fichier de cas */
	$ligne = fgets($fic);
	/** string chaine html de choix du délimiteur */
	$chainette = "<select size = '5' name = 'delimiteur'>";	
	$virgule = chr(44);
	/** Le séparateur est-il virgule?*/
	$ligne_virgule = explode($virgule,$ligne);
	/** integer à chaque étape, le nombre d'éléments trouvés par ce délimiteur
	si plus d'un élément est trouvé, on affichera le résultat*/
	$nb = count($ligne_virgule);
	if ( $nb > 1):
		/** string chaine montrant le résultat du choix de la virgule comme délimiteur */
		$chaine_virgule ="";
		foreach ($ligne_virgule as $mot)
		{
			$chaine_virgule .= "|$mot|";
		}
		/** string à chaque étape, indique s'il faut marquer l'élément comme sélectionné*/
		$selected = ($nb == 31) ? "selected ='selected'" :"";
		$chainette .= "<option $selected value = 44 >virgule $chaine_virgule</option>";
	endif;

	/** Le séparateur est-il point-virgule*/
	$point_virgule = chr(59);
	$ligne_point_virgule = explode($point_virgule,$ligne);
	/** string chaine montrant le résultat du choix du point-virgule comme délimiteur */
	$chaine_point_virgule = "";
	$nb = count($ligne_point_virgule);
	if ( $nb>1):
		foreach ($ligne_point_virgule as $mot)
		{
			$chaine_point_virgule .= "|$mot|";
		}
		$selected = ($nb == 31) ? "selected ='selected'" :"";
		$chainette .= "<option $selected value =59>point virgule $chaine_point_virgule</option>";
	endif;

	/** Le séparateur est-il deux points ?*/
	$deux_points = chr(58);		
	$ligne_deux_points = explode($deux_points,$ligne);
	/** string chaine montrant le résultat du choix de deux-points comme délimiteur */
	$chaine_deux_points ="";
	$nb = count($ligne_deux_points);
	if ( $nb >1):
		foreach ($ligne_deux_points as $mot)
		{
			$chaine_deux_points .= "|$mot|";
		}
		$selected = ($nb == 31) ? "selected ='selected'" :"";
		$chainette .= "<option $selected  value = 58>deux points $chaine_deux_points</option>";
	endif;
endif;
	
$chainette .="</select>";
print "
<body class= 'c8'>
	<div class= 'ligne_absolue' style = 'top:0%'>".
		T_TITRE_1."
	</div>
	<div class= 'ligne_absolue'  style = 'top:15%'>
		<form method = 'post' action = 'importer.php'>
			$t_consigne_delimiteur
			<p>$chainette
			
			<input type = 'hidden' name = 'base' value ='$base' />
			<input type = 'hidden' name = 'passe' value ='$passe' />
			<input type = 'hidden' name = 'nom_login' value ='$nom_login' />				
			<input type = 'hidden' name = 'nom_fichier' value ='$nom_fichier' />	</p>
			<p>$t_consigne_separateur
			<input type = 'radio' name= 'separateur' value ='1'  />$quote
			<input type = 'radio' name= 'separateur' value ='2' />$quote_double 
			<input type = 'radio' name= 'separateur' value ='0' />aucun 
			<button type = 'submit' >continuer </button></p>
			<p>$t_expl_separateur

		</form>
	</div>
   $bas_de_page";
?>
</body>
</html>
