<?PHP
/**
* \file importer.php
* \ingroup Réglisse
* version  stable
* \brief ouvre ou crée la base, les tables et y recopie le fichier de cas
* \param delimiteur
* \param separateur
* \param base
* \param passe
* \details format du fichier et noms des variables correspondantes
* \li nom (libre) : $nom_eleve 
* \li prenom (libre): $prenom_eleve
* \li sexe  (m/M/1|f/F/2): $sexe_eleve
* \li date de naissance (libre) : $date_naissance
* \li civilite du premier responsable (libre)	$civilite_responsable
* \li nom du premier responsable (libre): $nom_responsable
* \li première partie de l'adresse du premier responsable (libre): $adresse_1_responsable
* \li deuxième partie de l'adresse du premier responsable (libre): $adresse_2_responsable
* \li nom du lieu du premier responsable (libre) : $lieu_responsable
* \li code ptt du premier responsable (libre) :	$code_ptt_responsable
* \li bureau distributeur du premier responsable (libre) :	$bureau_responsable
* \li téléphone du premier responsable (libre) :	$telephone_responsable
* \li civilite du deuxième responsable (libre)	$civilite_responsable_2
* \li nom du deuxième responsable (libre): $nom_responsable_2
* \li première partie de l'adresse du deuxième responsable (libre): $adresse_1_responsable_2
* \li deuxième partie de l'adresse du deuxième responsable (libre): $adresse_2_responsable_2
* \li nom du lieu du deuxième responsable (libre) : $lieu_responsable_2
* \li code ptt du deuxième responsable (libre) :	$code_ptt_responsable_2
* \li bureau distributeur du deuxième responsable (libre) :	$bureau_responsable_2
* \li téléphone du deuxième responsable (libre) :	$telephone_responsable_2
* \li orientation ou filière (libre) quand le fichier comprend des élèves 
* qui doivent aller dans des filières différentes (des L, des S, des ES..) : $orientation
* \li les choix exclusifs de l'élève ($options obligatoires):
* <ol> 
		<li>la première langue vivante par exemple :$contrainte_1</li>
		<li>la deuxième langue vivante par exemple :$contrainte_2</li>
		<li>la troisième langue vivante par exemple :$contrainte_3</li>
		<li>enseignement de détermination 1: $contrainte_4</li>
		<li>enseignement de détermination 1: $contrainte_5</li>		
	</ol>		
* \li les choix additifs (options facultatives)
* <ol> 
		<li>option 1:$contrainte_6</li>
		<li>option:$contrainte_7</li>
		<li>option :$contrainte_8</li>
		<li>option: $contrainte_9</li>
		<li>option: $contrainte_10</li>		
	</ol>	
*/	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"> 
<head>
	<META http-equiv='Content-Type' content='text/html; charset=utf-8'>
	<title>Réglisse création des tables et lecture du fichier de données</title>
	<meta name="author" content="Billard" >
	<meta name ="keywords" content ="education, distribution of students into several classes">
		<LINK rel="stylesheet" href="styles.css" type="text/css">

<!--
	/GPL Licence - Réglisse
	
	Copyright (c) 2011, Michel Billard Sirakawa http://sibylle.ouvaton.org
 
	This file is part of Réglisse.

	Réglisse is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	Date: 15 juin 2011
	Version : 1
	Author : Michel Billard Sirakawa BillardMchl (at) aol (point) com
	Information site : http://sibylle.ouvaton.org
	///////////
	
	-->
	
</head>

<!-- 
==========================================================================
			Création de la base de données et des tables adaptées 
-->

<body style = 'background-color:lavender'>
<?PHP
	

class MyDB extends SQLite3
{
	function __construct($base, $passe)
	{
		try 
		{
			$this->open($base, 0666, $passe);
		}
		catch (Exception $e)
		{
			$this->open($base, 0666, $passe);
		}
	}
}

include ("reglisse.inc");
error_reporting(E_ALL);
/** string le délimiteur identifié dans identifier_separateur.php */
$delimiteur = chr($_POST['delimiteur']);
$val = ord ($delimiteur);

/** integer le séparateur identifié dans identifier_separateur.php */
$separateur = (isset($_POST['separateur'])) ? $_POST['separateur']: 0;
switch ($separateur):
	case 1:
		$separateur = $quote;
	break;
	case 2:
		$separateur = $quote_double;
	break;
	default:
		$separateur ="";
	endswitch;
	
/** string la base de données*/
$base = $_POST['base'];
/** string mot de passe de la base de données*/
$passe = $_POST['passe'];

/** string chemin du fichier de cas une fois recopié*/
$nom_fic_donnees = $_POST['nom_fichier'];

/** un objet sqlite*/
$db = new MyDB($base, $passe);
$db->close();
$db->open($base,0666, $passe);
	
/**
* Suppression de la table eleves à tout hasard
*/
$db->exec ("Drop table if exists `eleves`");
/** la table générale des élèves*/	
$db->exec
	("		
		CREATE TABLE `eleves`
		(
			`eleve_id` INTEGER NOT NULL , 
			`eleve_nom` MEDIUMTEXT DEFAULT NULL,
			`eleve_prenom` MEDIUMTEXT DEFAULT NULL,				
			`eleve_sexe` VARCHAR(1) DEFAULT NULL,
			`affecte` INTEGER DEFAULT NULL,
			`naissance` VARCHAR(20) DEFAULT NULL,
			`civilite_responsable` VARCHAR(3) DEFAULT NULL,
			`nom_responsable` MEDIUMTEXT DEFAULT NULL,
			`adresse_1_responsable` MEDIUMTEXT DEFAULT NULL,
			`adresse_2_responsable` MEDIUMTEXT DEFAULT NULL,
			`lieu_responsable` MEDIUMTEXT DEFAULT NULL,
			`code_ptt_responsable` VARCHAR(10) DEFAULT NULL,
			`bureau_responsable` MEDIUMTEXT DEFAULT NULL,
			`telephone_responsable` VARCHAR(15) DEFAULT NULL,
			`civilite_responsable_2` VARCHAR(3) DEFAULT NULL,
			`nom_responsable_2` MEDIUMTEXT DEFAULT NULL,
			`adresse_1_responsable_2` MEDIUMTEXT DEFAULT NULL,
			`adresse_2_responsable_2` MEDIUMTEXT DEFAULT NULL,
			`lieu_responsable_2` MEDIUMTEXT DEFAULT NULL,
			`code_ptt_responsable_2` VARCHAR(10) DEFAULT NULL,
			`bureau_responsable_2` MEDIUMTEXT DEFAULT NULL,
			`telephone_responsable_2` VARCHAR(15) DEFAULT NULL,
			`orientation` VARCHAR(20) DEFAULT NULL,
			`contrainte_1` VARCHAR(20) DEFAULT NULL,
			`contrainte_2` VARCHAR(20) DEFAULT NULL,
			`contrainte_3` VARCHAR(20) DEFAULT NULL,
			`contrainte_4` VARCHAR(20) DEFAULT NULL,
			`contrainte_5` VARCHAR(20) DEFAULT NULL,
			`contrainte_6` VARCHAR(20) DEFAULT NULL,
			`contrainte_7` VARCHAR(20) DEFAULT NULL,
			`contrainte_8` VARCHAR(20) DEFAULT NULL,
			`contrainte_9` VARCHAR(20) DEFAULT NULL,
			`contrainte_10` VARCHAR(20) DEFAULT NULL,
			 PRIMARY KEY (`eleve_id`)
		);
	");
/** la table des élèves incompatibles*/
$db->exec ("Drop table if exists `incompatibles`");
$db->exec (
		"CREATE TABLE  `incompatibles` 
		(
			`id` INTEGER NOT NULL,
			`eleve_id_1` INTEGER DEFAULT NULL,
			`eleve_id_2` INTEGER DEFAULT NULL,
			PRIMARY KEY (`id`)
		);"
	);

/** la table des élèves à rapprocher */	
$db->exec ("Drop table if exists `compatibles`");	
$db->exec (
		"CREATE TABLE  `compatibles` 
		(
			`id` INTEGER NOT NULL,
			`eleve_id_1` INTEGER DEFAULT NULL,
			`eleve_id_2` INTEGER DEFAULT NULL,
			PRIMARY KEY (`id`)
		);"
	);	
	
$db->exec ("Drop table if exists `particuliers`");
$db->exec (
		"CREATE TABLE `particuliers` 
		(
			`id` INTEGER NOT NULL ,
			`eleve_id` INTEGER DEFAULT NULL,
			`eleve_cas` INTEGER DEFAULT NULL,
			PRIMARY KEY (`id`)
		)"
	);

/** la table des affectations*/
$db->exec ("Drop table if exists `affectes`");
$db->exec ("		
		CREATE TABLE `affectes` 
		(
			`eleve_id` INTEGER DEFAULT NULL,
			`classe_id` INTEGER DEFAULT NULL,
			`mobile` varchar(1) DEFAULT 'T'
		)"
	);
/** la table des intitulés des options*/
$db->exec ("Drop table if exists `intitules`");
$db->exec ("		
		CREATE TABLE `intitules` 
		(
			`intitule_31`  MEDIUMTEXT,
			`intitule_30`  MEDIUMTEXT,
			`intitule_29`  MEDIUMTEXT,
			`intitule_28`  MEDIUMTEXT,
			`intitule_27`  MEDIUMTEXT,
			`intitule_26`  MEDIUMTEXT,
			`intitule_25`  MEDIUMTEXT,
			`intitule_24`  MEDIUMTEXT,
			`intitule_23`  MEDIUMTEXT,
			`intitule_22`  MEDIUMTEXT,
			`intitule_21`  MEDIUMTEXT,
			`intitule_20`  MEDIUMTEXT,
			`intitule_19`  MEDIUMTEXT,
			`intitule_18`  MEDIUMTEXT,
			`intitule_17`  MEDIUMTEXT,
			`intitule_16`  MEDIUMTEXT,
			`intitule_15`  MEDIUMTEXT,
			`intitule_14`  MEDIUMTEXT,
			`intitule_13`  MEDIUMTEXT,
			`intitule_12`  MEDIUMTEXT,
			`intitule_11`  MEDIUMTEXT,
			`intitule_10`  MEDIUMTEXT,
			`intitule_9`  MEDIUMTEXT,
			`intitule_8`  MEDIUMTEXT,
			`intitule_7`  MEDIUMTEXT,
			`intitule_6`  MEDIUMTEXT,
			`intitule_5`  MEDIUMTEXT,
			`intitule_4`  MEDIUMTEXT,
			`intitule_3`  MEDIUMTEXT,
			`intitule_2`  MEDIUMTEXT,
			`intitule_1`  MEDIUMTEXT	
		)"
	);
		
$fic = fopen ($nom_fic_donnees, "r");
/** array les codes de sexe reconnus */
$codes_sexes = array (1,2, "m","f","M","F");
/** array les codes sexe utilisés*/
$sexes = array("M", "F");
	
/**
* Lecture du fichier eleves.csv et report dans la table eleves
*/

/** handle */
$erreurs = "";
/** integer le numéro de ligne pour isoler la ligne d'entetes*/
$num_lig = 1;
/**integer le numero de l'élève traité*/
$num_eleve = 1;
/** buffer*/
$tampon = fgets($fic);	
/**string le tampon débarrassé de ses séparateurs de texte */
$tampon_pur = str_replace ($separateur, "", $tampon);
/** array la ligne du cas transformée en tableau*/
$items = explode ($delimiteur, $tampon_pur);
if (count ($items) < 3): // il faut au moins 3 éléments pour chaque cas
	$erreurs .= T_LIGNE_ANORMALE.$tampon;
else:
	$items = array_pad($items, 30, ""); // complémentation 
	/*mise à jour de la table intitules*/
	$requete = "Insert into intitules 
	(
		intitule_1, intitule_2, intitule_3, intitule_4, intitule_5, 
		intitule_6, intitule_7, intitule_8, intitule_9, intitule_10,
		intitule_11, intitule_12, intitule_13, intitule_14, intitule_15, 
		intitule_16, intitule_17, intitule_18, intitule_19, intitule_20,						
		intitule_21, intitule_22, intitule_23, intitule_24, intitule_25, 
		intitule_26, intitule_27, intitule_28, intitule_29, intitule_30, intitule_31
	) 
	values 
	(
		'{$items[0]}', '{$items[1]}','{$items[2]}','{$items[3]}','{$items[4]}',
		'{$items[5]}','{$items[6]}','{$items[7]}','{$items[8]}','{$items[9]}',
		'{$items[10]}', '{$items[11]}','{$items[12]}','{$items[13]}','{$items[14]}',
		'{$items[15]}','{$items[16]}','{$items[17]}','{$items[18]}','{$items[19]}',
		'{$items[20]}', '{$items[21]}','{$items[22]}','{$items[23]}','{$items[24]}',
		'{$items[25]}','{$items[26]}','{$items[27]}','{$items[28]}','{$items[29]}','{$items[30]}'
	)";
	$db->exec($requete);
endif;

/*pour le reste du fichier de cas*/
while (($tampon = fgets($fic)) !== false) :
	$tampon_pur = str_replace ($separateur, "", $tampon);
	$items = explode ($delimiteur, $tampon_pur);
	if (count ($items) < 3):
		$erreurs .= T_LIGNE_ANORMALE.$tampon;
	endif;
	$sexe_eleve = trim($items[2]);
	$nom_eleve = ucfirst(htmlentities ($items[0], ENT_QUOTES, "UTF-8"));
	$prenom_eleve = htmlentities ($items[1], ENT_QUOTES, "UTF-8");			
	$date_naissance = isset ($items[3]) ? $items[3] : "__-_________-____";
	$civilite_responsable = isset($items[4]) ? $items[4]: "";
	$nom_responsable = isset($items[5]) ? $items[5]: "";
	$adresse_1_responsable = isset($items[6]) ? $items[6]: "";
	$adresse_2_responsable = isset($items[7]) ? $items[7]: "";
	$lieu_responsable = isset($items[8]) ? $items[8]: "";
	$code_ptt_responsable = isset($items[9]) ? $items[9]: "";
	$bureau_responsable = isset($items[10]) ? $items[10]: "";
	$telephone_responsable = isset($items[11]) ? $items[11]: "";
	$civilite_responsable_2 = isset($items[12]) ? $items[12]: "";
	$nom_responsable_2 = isset($items[13]) ? $items[13]: "";
	$adresse_1_responsable_2= isset($items[14]) ? $items[14]: "";
	$adresse_2_responsable_2 = isset($items[15]) ? $items[15]: "";
	$lieu_responsable_2 = isset($items[16]) ? $items[16]: "";
	$code_ptt_responsable_2 = isset($items[17]) ? $items[17]: "";
	$bureau_responsable_2 = isset($items[18]) ? $items[18]: "";
	$telephone_responsable_2 = isset($items[19]) ? $items[19]: "";	
	$orientation = isset($items[20]) ? strtoupper(trim($items[20])): "";				
	$contrainte_10 = isset($items[30]) ? strtoupper(trim($items[30])): "";		
	$contrainte_1 = isset($items[21]) ? strtoupper(trim($items[21])): "";	
	$contrainte_2 = isset($items[22]) ? strtoupper(trim($items[22])): "";
	$contrainte_3 = isset($items[23]) ? strtoupper(trim($items[23])): "";
	$contrainte_4 = isset($items[24]) ? strtoupper(trim($items[24])): "";		
	$contrainte_5 = isset($items[25]) ? strtoupper(trim($items[25])): "";
	$contrainte_6 = isset($items[26]) ? strtoupper(trim($items[26])): "";	
	$contrainte_7 = isset($items[27]) ? strtoupper(trim($items[27])): "";
	$contrainte_8 = isset($items[28]) ? strtoupper(trim($items[28])): "";
	$contrainte_9 = isset($items[29]) ? strtoupper(trim($items[29])): "";
	/**
	* le sexe étant un critère de répartition, il faut s'assurer qu'il est normalisé
	*/
	switch ($sexe_eleve):
			case 1:
			case "m":
			case "M":
			case "masculin":
			case "Masculin":
				$sexe_eleve = "M";
			break;
			default:
				$sexe_eleve= "F";
	endswitch;
	$requete = "Insert into eleves 
	(
		eleve_id, 
		eleve_nom, 
		eleve_prenom, 						
		eleve_sexe, 
		affecte, 
		naissance,
		civilite_responsable,
		nom_responsable,
		adresse_1_responsable,
		adresse_2_responsable,
		code_ptt_responsable,
		bureau_responsable,
		telephone_responsable,
		civilite_responsable_2,
		nom_responsable_2,
		adresse_1_responsable_2,
		adresse_2_responsable_2,
		code_ptt_responsable_2,
		bureau_responsable_2,
		telephone_responsable_2,
		orientation,
		contrainte_1,
		contrainte_2,
		contrainte_3,
		contrainte_4,
		contrainte_5,
		contrainte_6,
		contrainte_7,
		contrainte_8,
		contrainte_9,
		contrainte_10
	) 
	values 
	(
		$num_eleve, 
		'$nom_eleve', 
		'$prenom_eleve',
		'$sexe_eleve', 
		0, 
		'$date_naissance',
		'$civilite_responsable',
		'$nom_responsable',
		'$adresse_1_responsable',
		'$adresse_2_responsable',
		'$code_ptt_responsable',
		'$bureau_responsable',
		'$telephone_responsable',
		'$civilite_responsable_2',
		'$nom_responsable_2',
		'$adresse_1_responsable_2',
		'$adresse_2_responsable_2',
		'$code_ptt_responsable_2',
		'$bureau_responsable_2',
		'$telephone_responsable_2',
		'$orientation',
		'$contrainte_1',						
		'$contrainte_2',
		'$contrainte_3',
		'$contrainte_4',
		'$contrainte_5',
		'$contrainte_6',
		'$contrainte_7',
		'$contrainte_8',
		'$contrainte_9',
		'$contrainte_10'
	)";
	$resultat = $db->exec ($requete);
	$num_eleve++;
endwhile;
$db->close();
/** $chaine est le code html */
$chaine = "<body style = 'background-color:lavender'>
			<div class = 'ligne_absolue'  style= 'top:0%; left:0%;'>
				".T_TITRE_1."
			</div>
			
			<div class = 'ligne_absolue' 	style= 'top:15%; left:0%; border:none'>		
				<div class= 'cellule'>
					<form method ='post' action = 'repartir_avec_particularites.php'>
						<input type = 'hidden' name= 'base' value = '$base' />
						<input type = 'hidden' name= 'passe' value = '$passe' />	
						".I_NB."
						<button type = 'submit'>".T_REPARTITIONS_PARTICULARITES."</button>
					</form>
				</div>
				<div class= 'cellule'>
					<form method ='post' action = 'saisir_particularites.php'>
						<input type = 'hidden' name= 'base' value = '$base' />
						<input type = 'hidden' name= 'passe' value = '$passe' />	
						<button type = 'submit'>".T_RESAISIR_PARTICULARITES."</button>
					</form>
				</div>
				<div class= 'cellule'>
					<form method ='post' action = 'preciser_contraintes.php'>
						<input type = 'hidden' name= 'base' value = '$base' />
						<input type = 'hidden' name= 'passe' value = '$passe' />	
						<button type = 'submit'>".T_REPARTITIONS_CONTRAINTES."</button>
					</form>
				</div>
				<div class= 'cellule'>
					<form method ='post' action = 'repartition_libre.php'>
						<input type = 'hidden' name= 'base' value = '$base' />
						<input type = 'hidden' name= 'passe' value = '$passe' />	
						".I_NB."
						<button type = 'submit'>".T_REPARTITIONS_LIBRES."</button>
					</form>
				</div>			
		</div>
	$bas_de_page";
	print "$chaine";	
?>
</body>
</html>
