<?PHP
/**
* \file preciser_contraintes.php
* \ingroup Réglisse
* \version  stable
* \brief affichage de contrôle
* \details 
* Lecture de la table intitules (première ligne du fichier de cas)
* \n
* Lecture de la table eleves par contraintes
* \n pour chaque contrainte :
* \li identification des variantes de la contrainte (les choix possibles)
* \li pour chaque variante, comptage des individus l'ayant choisie 
*
* Lecture de la table eleves par noms
*  affichage du nom, du prénom et des choix de chacun
*/
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"> 
<head>
<meta http-equiv="content-type" 
		content="text/html;charset=utf-8" />
	<title>Réglisse préciser les contraintes</title>
	<meta name="author" content="Billard" />
	<meta name ="keywords" content ="education, distribution of students into several classes" />
	<link rel="stylesheet" type="text/css" href="styles.css" media="screen" />


<!--
	/////////  GPL Licence - Cohortes
	
	Copyright (c) 2011, Michel Billard Sirakawa http://sibylle.ouvaton.org
 
	This file is part of cohortes.

	Cohortes is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	Date: 15 juin 2011
	Version :Cohortes version 1
	Author : Michel Billard Sirakawa BillardMchl (at) aol (point) com
	Information site : http://sibylle.ouvaton.org
	///////////
	
	-->
   
<script type='text/javascript'>

var actions = new Array();
actions[0] = 'menu_general.php';
actions [1] = 'repartir_avec_contraintes.php';	
actions[2] = 'repartir_avec_contraintes_inverses.php';
actions[3] = 'repartir_avec_contraintes_croisees.php';
actions[4] ='repartition_jacquard.php';
actions[5] = 'ordonner_contraintes.php';
actions[6] = 'choisir_fichier.php';
	function change_action (action)
{
	action=actions[action];
	document.forms.formulaire.action=action;
}
</script>
</head>
<!-- Affinement des contraintes-->
<body style = 'width:98%;background-color:lavender'>
<?PHP
	include ("reglisse.inc");
	class MyDB extends SQLite3
	{
		function __construct($base, $passe)
		{
			try 
			{
				$this->open($base,	 SQLITE3_OPEN_READWRITE, $passe);
			}
			catch (Exception $e)
			{
				$this->open($base, SQLITE3_OPEN_CREATE, $passe);
			}
		}
	}
	$nb_classes = isset($_POST['nb_classes'] ) ? $_POST['nb_classes']  : "";
	/** string nom de la base de données*/
	$base = $_POST['base'];
	/** string mot de passe de la base de données*/
	$passe = $_POST['passe'];	
	/** objet SQLITE*/
	$db = new MyDB($base, $passe);
	$db->close();
	$db->open($base, 0666, $passe);
		
	/** comptage de l'effectif*/
	$requete = "select count(eleve_id)  from `eleves`";
	$resultat = $db->query ($requete);
	$ligne = $resultat ->fetchArray(); 
	
	/** integer effectif*/
	$nb_individus = $ligne[0];

	/** string requete de recherche des intitulés */
	$requete = "select * from intitules";
	$resultat = $db->query ($requete);
	$ligne = $resultat->fetchArray();
	
	/** array tableau des intitulés des contraintes*/
	$intitules = array();
	$intitules['filiere'] = $ligne['intitule_21'];
	$intitules['contrainte_1'] = "<span class = 'titre_5'>". $ligne['intitule_22']."</span>";
	$intitules['contrainte_2'] = "<span class = 'titre_5'>". $ligne['intitule_23']."</span>";
	$intitules['contrainte_3'] ="<span class = 'titre_5'>". $ligne['intitule_24']."</span>";
	$intitules['contrainte_4'] ="<span class = 'titre_5'>". $ligne['intitule_25']."</span>";
	$intitules['contrainte_5'] = "<span class = 'titre_5'>". $ligne['intitule_26']."</span>";
	$intitules['contrainte_6'] = "<span class = 'titre_5'>". $ligne['intitule_27']."</span>";
	$intitules['contrainte_7'] ="<span class = 'titre_5'>". $ligne['intitule_28']."</span>";
	$intitules['contrainte_8'] = "<span class = 'titre_5'>". $ligne['intitule_29']."</span>";
	$intitules['contrainte_9'] = "<span class = 'titre_5'>". $ligne['intitule_30']."</span>";
	$intitules['contrainte_10'] = "<span class = 'titre_5'>". $ligne['intitule_31']."</span>";
	
	
	/** array : identification et comptage de la contrainte 1*/
	$contrainte_1 = array();
	$requete = "select contrainte_1 from `eleves`  group by contrainte_1";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
		$contrainte_1[$indice++]['nom']= $ligne['contrainte_1'];
	endwhile;
	$requete = "select count( eleve_id) from `eleves` group by contrainte_1";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
		$contrainte_1[$indice++]['effectif'] = $ligne[0];
	endwhile;


	/** array identification et comptage de la contrainte 2*/
	$contrainte_2 = array();
	$requete = "select contrainte_2   from `eleves`   group by contrainte_2";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
		$contrainte_2[$indice++]['nom']= $ligne['contrainte_2'];
	endwhile;
	$requete = "select count( eleve_id)  from `eleves`  group by contrainte_2";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
		$contrainte_2[$indice++]['effectif'] = $ligne[0];
	endwhile;

	/** array  identification et comptage de la contrainte 3*/
	$contrainte_3 = array();
	$requete = "select contrainte_3  from `eleves`   group by contrainte_3";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_3[$indice++]['nom']= $ligne['contrainte_3'];
	endwhile;
	$requete = "select count( eleve_id)  from `eleves`  group by contrainte_3";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_3[$indice++]['effectif'] = $ligne[0];
	endwhile;

	/** array identification et comptage de la contrainte 4*/
	$contrainte_4 = array();
	$requete = "select contrainte_4  from `eleves`   group by contrainte_4";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_4[$indice++]['nom']= $ligne['contrainte_4'];
	endwhile;
	$requete = "select count( eleve_id)  from `eleves`   group by contrainte_4";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_4[$indice++]['effectif'] = $ligne[0];
	endwhile;
	
	/** array identification et comptage de la contrainte 5*/
	$contrainte_5 = array();
	$requete = "select contrainte_5 from `eleves`   group by contrainte_5";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_5[$indice++]['nom']= $ligne['contrainte_5'];
	endwhile;
	$requete = "select count( eleve_id)  from `eleves`   group by contrainte_5";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_5[$indice++]['effectif'] = $ligne[0];
	endwhile;
	
	/** array identification et comptage de la contrainte 6*/
	$contrainte_6 = array();
	$requete = "select contrainte_6  from `eleves`   group by contrainte_6";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_6[$indice++]['nom']= $ligne['contrainte_6'];
	endwhile;
	$requete = "select count( eleve_id)  from `eleves`   group by contrainte_6";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_6[$indice++]['effectif'] = $ligne[0];
	endwhile;
	
	/** array identification et comptage de la contrainte 7*/
	$contrainte_7 = array();
	$requete = "select contrainte_7   from `eleves`   group by contrainte_7";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_7[$indice++]['nom']= $ligne['contrainte_7'];
	endwhile;
	$requete = "select count( eleve_id)  from `eleves`   group by contrainte_7";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_7[$indice++]['effectif'] = $ligne[0];
	endwhile;

	/** array identification et comptage de la contrainte 8*/
	$contrainte_8 = array();
	$requete = "select contrainte_8  from `eleves`   group by contrainte_8";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_8[$indice++]['nom']= $ligne['contrainte_8'];
	endwhile;
	$requete = "select count( eleve_id)  from `eleves`   group by contrainte_8";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_8[$indice++]['effectif'] = $ligne[0];
	endwhile;
	
	/** array identification et comptage de la contrainte 9*/
	$contrainte_9 = array();
	$requete = "select contrainte_9  from `eleves`   group by contrainte_9";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_9[$indice++]['nom']= $ligne['contrainte_9'];
	endwhile;
	$requete = "select count( eleve_id)  from `eleves` group by contrainte_9";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_9[$indice++]['effectif'] = $ligne[0];
	endwhile;

	/** array identification et comptage de la contrainte 10*/
	$contrainte_10 = array();
	$requete = "select contrainte_10 from `eleves`   group by contrainte_10";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_10[$indice++]['nom']= $ligne['contrainte_10'];
	endwhile;
	$requete = "select count( eleve_id) from `eleves`  group by contrainte_10";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$contrainte_10[$indice++]['effectif'] = $ligne[0];
	endwhile;

	/** array identification et comptage des orientations */
	$orientations = array();
	$requete = "select orientation  from `eleves`   group by orientation";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$orientations[$indice++]['nom']= $ligne['orientation'];
	endwhile;
	$requete = "select count( eleve_id)  from `eleves`   group by orientation";
	$resultat = $db->query ($requete);
	$indice = 1;
	while ($ligne = $resultat->fetchArray()):
				$orientations[$indice++]['effectif'] = $ligne[0];
	endwhile;
	
	/** string texte de l'affichage des affectations*/
	$t_orientations = " 
	<div class ='ligne_absolue' style= ' padding:0.1em;left:0%; top:10%;width:16.5%; height:15%; border: black medium solid; overflow:scroll'>".
	T_AFFECTATION."<br /><select name='filiere'>";
	foreach($orientations as $orientation)
	{
		$intitule = ($orientation['nom']!=  "") ?  $orientation['nom'] : T_SANS_AFFECTATION;
		$effectif = $orientation['effectif'];
		$t_orientations .= "<option value ='$intitule'>".$intitule." :".$effectif. "</option>";
	}
	$t_orientations .= "</select></div>";

	/** string texte de l'affichage de la contrainte 1*/
	$t_contrainte_1 = "
		<div class ='ligne_absolue' style= ' left:19%;  top:10%;width:7%;  height:15%; border: black medium solid;  padding:0.1em;overflow:scroll'>".$intitules['contrainte_1']."<br />";
	foreach($contrainte_1 as $contrainte)
	{
		$intitule = ($contrainte['nom']!=  "") ?  $contrainte['nom'] : T_SANS_AFFECTATION;
		$effectif = $contrainte['effectif'];
		$t_contrainte_1 .= "<span class ='item'>".$intitule." :".$effectif. "</span><br />";
	}
	$t_contrainte_1 .= "</div>";
	
	/** string texte de l'affichage de la contrainte 2*/
	$t_contrainte_2 = "
		<div class ='ligne_absolue' style= ' left:26.5%;  top:10%;width:7%; height:15%;  border: black medium solid; padding:0.1em;overflow:scroll'>".$intitules['contrainte_2']."<br  />";
	foreach($contrainte_2 as $contrainte)
	{
		$intitule = ($contrainte['nom']!=  "") ?  $contrainte['nom'] : T_SANS_AFFECTATION;
		$effectif = $contrainte['effectif'];
		$t_contrainte_2 .= "<span class ='item'>".$intitule." :".$effectif. "</span><br />";
	}
	$t_contrainte_2 .= "</div>";

	/** string texte de l'affichage de la contrainte 3*/
	$t_contrainte_3 = "
		<div class ='ligne_absolue' style= ' left:34%;  top:10%;width:7%;  height:15%; border: black medium solid; padding:0.1em;overflow:scroll'>".$intitules['contrainte_3']."<br />";
	foreach($contrainte_3 as $contrainte)
	{
		$intitule = ($contrainte['nom']!=  "") ?  $contrainte['nom'] : T_SANS_AFFECTATION;
		$effectif = $contrainte['effectif'];
		$t_contrainte_3 .= "<span class ='item'>".$intitule." :".$effectif. "</span><br />";
	}
	$t_contrainte_3 .= "</div>";

	/** string texte de l'affichage de la contrainte 4*/
	$t_contrainte_4 = "
		<div class ='ligne_absolue' style= ' left:41.5%;  top:10%;width:7%;  height:15%; border: black medium solid; padding:0.1em;overflow:scroll'>".$intitules['contrainte_4']."<br />";
	foreach($contrainte_4 as $contrainte)
	{
		$intitule = ($contrainte['nom']!=  "") ?  $contrainte['nom'] : T_SANS_AFFECTATION;
		$effectif = $contrainte['effectif'];
		$t_contrainte_4 .= "<span class ='item'>".$intitule." :".$effectif. "</span><br />";
	}
	$t_contrainte_4 .= "</div>";

	/** string texte de l'affichage de la contrainte 5*/
	$t_contrainte_5 = "
		<div class ='ligne_absolue' style= ' left:49%; top:10%;width:7%;  height:15%; border: black medium solid; padding:0.1em;overflow:scroll'>".$intitules['contrainte_5']."<br />";
	foreach($contrainte_5 as $contrainte)
	{
		$intitule = ($contrainte['nom']!=  "") ?  $contrainte['nom'] : T_SANS_AFFECTATION;
		$effectif = $contrainte['effectif'];
		$t_contrainte_5 .= "<span class ='item'>".$intitule." :".$effectif. "</span><br />";
	}
	$t_contrainte_5 .= "</div>";

	/** string texte de l'affichage de la contrainte 6*/
	$t_contrainte_6 = "
		<div class ='ligne_absolue' style= ' left:58.5%; top:10%;width:7%;  height:15%; border: black medium solid; padding:0.1em;overflow:scroll'>".$intitules['contrainte_6']."<br />";
	foreach($contrainte_6 as $contrainte)

	{
		$intitule = ($contrainte['nom']!=  "") ?  $contrainte['nom'] : T_SANS_AFFECTATION;
		$effectif = $contrainte['effectif'];
		$t_contrainte_6 .= "<span class ='item'>".$intitule." :".$effectif. "</span><br />";
	}
	$t_contrainte_6 .= "</div>";

	/** string texte de l'affichage de la contrainte 7*/
	$t_contrainte_7 = "
		<div class ='ligne_absolue' style= ' left:66%;  top:10%;width:7%;  height:15%; border: black medium solid; padding:0.1em;overflow:scroll'>".$intitules['contrainte_7']."<br />";
	foreach($contrainte_7 as $contrainte)
	{
		$intitule = ($contrainte['nom']!=  "") ?  $contrainte['nom'] : T_SANS_AFFECTATION;
		$effectif = $contrainte['effectif'];
		$t_contrainte_7 .= "<span class ='item'>".$intitule." :".$effectif. "</span><br />";
	}
	$t_contrainte_7 .= "</div>";

	/** string texte de l'affichage de la contrainte 8*/
	$t_contrainte_8 = "
		<div class ='ligne_absolue' style= ' left:73.5%;  top:10%; width:7%;  height:15%; border: black medium solid; padding:0.1em;overflow:scroll'>".$intitules['contrainte_8']."<br />";
	foreach($contrainte_8 as $contrainte)
	{
		$intitule = ($contrainte['nom']!=  "") ?  $contrainte['nom'] : T_SANS_AFFECTATION;
		$effectif = $contrainte['effectif'];
		$t_contrainte_8 .= "<span class ='item'>".$intitule." :".$effectif. "</span><br />";
	}
	$t_contrainte_8 .= "</div>";

	/** string texte de l'affichage de la contrainte 9*/
	$t_contrainte_9 = "
		<div class ='ligne_absolue' style= ' left:81%;  top:10%; width:7%;  height:15%; border: black medium solid; padding:0.1em;overflow:scroll'>".$intitules['contrainte_9']."<br />";
	foreach($contrainte_9 as $contrainte)
	{
		$intitule = ($contrainte['nom']!=  "") ?  $contrainte['nom'] : T_SANS_AFFECTATION;
		$effectif = $contrainte['effectif'];
		$t_contrainte_9 .= "<span class ='item'>".$intitule." :".$effectif. "</span><br />";
	}
	$t_contrainte_9 .= "</div>";

	/** string texte de l'affichage de la contrainte 10*/
	$t_contrainte_10 = "
		<div class ='ligne_absolue' style= ' left:88.5%;  top:10%; width:7%;  height:15%; border: black medium solid; padding:0.1em;overflow:scroll'>".$intitules['contrainte_10']."<br />";
	foreach($contrainte_10 as $contrainte)
	{
		$intitule = ($contrainte['nom']!=  "") ?  $contrainte['nom'] : T_SANS_AFFECTATION;
		$effectif = $contrainte['effectif'];
		$t_contrainte_10 .= "<span class ='item'>".$intitule." :".$effectif. "</span><br />";
	}
	$t_contrainte_10 .= "</div>";

	/** Liste des élèves */
	$requete = "select * from `eleves` order by eleve_nom";
	$resultat = $db->query($requete);
	$t_liste = "<div class ='ligne_absolue' style= ' left:0%; top:26%;  height:59%; border: black medium solid; padding:0.1em;overflow:scroll'>";
	$top =0;
	while ($ligne = $resultat->fetchArray()):
	$str_top = $top."%";
		$nom = $ligne['eleve_nom'];
		$prenom = $ligne['eleve_prenom'];
		$l_nom = strlen(html_entity_decode($nom));
		$orientation = ( $ligne['orientation'] != "") ? $ligne['orientation'] : T_SANS_AFFECTATION ;
		$lv_1 = $ligne['contrainte_1'];
		$lv_2 = $ligne['contrainte_2'];
		$lv_3 = $ligne['contrainte_3'];	
		$spe_1 = $ligne['contrainte_4'];
		$spe_2 = $ligne['contrainte_5'];	
		$opt_1 = $ligne['contrainte_6'];
		$opt_2 = $ligne['contrainte_7'];	
		$opt_3 = $ligne['contrainte_8'];	
		$opt_4 = $ligne['contrainte_9'];	
		$opt_5 = $ligne['contrainte_10'];	
		/**	string le texte de la liste des élèves*/
		$t_liste .= "
		<div class= 'ligne' style = 'left:1%; border-width: thin; border-style:none none solid none;'>
			<div class = 'cellule_sans'>".$nom."</div>
			<div class = 'cellule_sans'>".$prenom."</div>		
			<div class= 'cellule_sans'>".$orientation."</div>
			<div class= 'cellule_sans'>".$lv_1."</div>
			<div class= 'cellule_sans'>".$lv_2."</div>	
			<div class= 'cellule_sans'>".$lv_3."</div>	
			<div class= 'cellule_sans'>".$spe_1."</div>	
			<div class= 'cellule_sans'>".$spe_2."</div>	
			<div class= 'cellule_sans'>".$opt_1."</div>	
			<div class= 'cellule_sans'>".$opt_2."</div>	
			<div class= 'cellule_sans'>".$opt_3."</div>	
			<div class= 'cellule_sans'>".$opt_4."</div>	
			<div class= 'cellule_sans'>".$opt_5."</div>	
		</div>
		";

		$t_liste .= "<br />";
		$top+=10;
	endwhile;
	$t_liste .= "</div>";

	$chaine = T_TITRE_1."
		<form id ='formulaire' method ='post' action = 'repartir_avec_contraintes.php'>
			<div>
				<input type = 'hidden' name ='base' value ='$base' />
				<input type = 'hidden' name ='passe' value ='$passe' />		
				$t_orientations
				$t_contrainte_1
				$t_contrainte_2
				$t_contrainte_3
				$t_contrainte_4
				$t_contrainte_5
				$t_contrainte_6
				$t_contrainte_7
				$t_contrainte_8
				$t_contrainte_9
				$t_contrainte_10
				$t_liste
				
				<div class= 'ligne_boutons' style='top:86%; right:1%;border:none'>
					<div class = 'cellule'>
					<button type = 'submit' alt= 'Retour au menu' title='Retour au menu' onClick = 'change_action(0)'>".T_RETOUR_MENU."</button>
				</div>	
				
				<div class = 'cellule_menus_finale'>
					
					<button type = 'submit' alt = 'Réimporter des données' title = 'Réimporter des données' onClick = 'change_action(6)'>".T_REIMPORTER."</button>
				</div>	
				
				<div class= 'cellule_menus item1' >
				".T_NB."
					<input type ='text' size ='3' name = 'nb_classes'  value ='1' />
				</div>
				
				<div class = 'cellule_menus'>
					<button type = 'submit' alt ='Contraintes simples' title='Penser à préciser le nombre de classes' onClick = 'change_action(1)'>".T_REPARTIR_CONTRAINTES_SIMPLES."</button>
				</div>
				
				<div class = 'cellule_menus'>
				<button type = 'submit' alt ='Contraintes inverséees' title='Penser à préciser le nombre de classes' onClick = 'change_action(2)'>".T_REPARTIR_CONTRAINTES_INVERSEES."</button>
				</div>
				<div class = 'cellule_menus'>
					<button type = 'submit' alt ='Contraintes croisées' title='Penser à préciser le nombre de classes'onClick = 'change_action(3)'>".T_REPARTIR_CONTRAINTES_CROISEES."</button>
				</div>	
				<div class = 'cellule_menus'>
					<button >en projet</button>
				</div>	
				<div class = 'cellule_menus' style='border-style : inset inset inset none'>
					<button type = 'submit' alt ='Ordonner les contraintes' title='Ordonner les contraintes' onClick = 'change_action(5)'>".T_ORDONNER_CONTRAINTES."</button>
				</div>	
			</div>
		</form>
	</div>
		";
print "$chaine $bas_de_page";
?>

</body>
</html>
