<?PHP
/**
* \file repartir_avec_contraintes_inverses.php
* \brief répartition selon l'ordre inverse des contraintes
* \ingroup Réglisse
* \version  stable
* \details groupement selon la contrainte 10, puis à l'intérieur de celle-ci par la contrainte 9...
* \n répartition initiale exclusivement fondée sur les contraintes, 
* \n répartition ajustée optionnelle tenant compte des particularités et d'un seuil de ressemblance
* \todo intégrer grouper
*/
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"> 
<head>
	<META http-equiv='Content-Type' content='text/html; charset=utf-8'>
	<title>Réglisse répartir avec contraintes</title>
	<meta name="author" content="Billard" >
	<meta name ="keywords" content ="education, distribution of students into several classes">
		<LINK rel="stylesheet" href="styles.css" type="text/css">
<!--
/////////  GPL Licence - Cohortes
	
	Copyright (c) 2011, Michel Billard Sirakawa http://sibylle.ouvaton.org
 
	This file is part of cohortes.

	Cohortes is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	Date: 15 juin 2011
	Version :Cohortes version 1
	Author : Michel Billard Sirakawa BillardMchl (at) aol (point) com
	Information site : http://sibylle.ouvaton.org
	///////////
	
	-->
	
</head>
<!-- Répartir avec contraintes-->
<body style = 'width:98%;background-color:lavender'>
<?PHP
	include ("reglisse.inc");
	error_reporting(E_ALL);
	/*=========================================================================
	===========================================================================
	FONCTIONS
	===========================================================================
	===========================================================================/*
	/*
	______________
	|lire_tableau |
	---------------
	*/
	/**
	* \fn lire_table($db, $table)
	* \brief lecture des tables eleves, particuliers, compatibles
	* et incompatibles et report dans le tableau affectables.
	* \param $db objet sqlite
	* \return array affectables
	*/
	function lire_table($db)
	{
		/** string $requete consultation de la table des élèves*/
		$requete = "select * from `eleves`";
		$resultat_liste = $db->query ($requete);

		/** 
		* array  $affectables des affectations des élèves indicé par l'id de l'élève
		* \li $affectables[$id]['id'] = $id;
		* \li $affectables[$id]['sexe'] = $sexe;
		* \li	$affectables[$id]['affectation'] = 0;
		* \li	$affectables[$id]['nom'] = $nom;
		* \li		$affectables[$id]['cas']= $cas; cas particuliers
		*/
		$affectables = array();
		/**
		* array liste_cas_p liste des id des cas particuliers
		*/
		$liste_cas_p = array();
		/**
		* array liste_cas_p liste des id des  élèves ayant des affinités
		* positives avec le nombre d'affinités de chacun
		*/
		$liste_cas_c = array();	
		/**
		* array liste_cas_p liste des id des élèves ayant des affinités
		* négatives avec le nombre d'affinités de chacun
		*/		
		$liste_cas_i = array();		
		/** 
		* integer $nb_a_affecter nombre d'élèves à affecter 
		*/
		$nb_a_affecter = 0;
		
		/** integer $nb_m nombre de masculins*/
		$nb_m= 0;
		
		/** integer $ajustements nombre d'ajustements à effectuer */
		$ajustements = 0;

		/** pour toutes les lignes de la table eleves*/
		while ($ligne = $resultat_liste->fetchArray()):
			$jacquard = jacquardiser_cas($ligne);
			$id = $ligne['eleve_id'];
			$sexe = $ligne['eleve_sexe'];	
			$nom = $ligne ['eleve_nom'];
			$affectation = $ligne['affecte'];
			$affectables[$id]['id'] = $id;
			$affectables[$id]['sexe'] = $sexe;
			$affectables[$id]['affectation'] = $affectation;	
			$affectables[$id]['nom'] = $nom;
			$affectables[$id]['jacquard'] = $jacquard;
			$nb_a_affecter ++;
			$nb_m += ($sexe == 'M') ? 1 :0;
			/** string l'élève en cours, est-il un cas particulier ?*/
			$req = "select * from `particuliers` where eleve_id = $id";
			$res = $db->query  ($req);
			if ($ligne = $res ->fetchArray()):
				$ajustements ++;
				$cas = $ligne['eleve_cas'];
				$affectables[$id]['cas']= $cas;
				$liste_cas_p[$id]['id'] = $id;
			else:
				$affectables[$id]['cas'] = 0;
			endif;
			
			/** string  l'élève en cours, a-t-il des affinités positives ?*/
			$req = "select * from `compatibles` where eleve_id_1 = $id";
			$res = $db->query  ($req);
			$compatibles = array();
			while ($un_cas = $res->fetchArray()):
				$ajustements+=1;
				$compatibles [] = $un_cas['eleve_id_2'];
			endwhile;
			$nb_c =count($compatibles) ;
			if ($nb_c> 0):
				$liste_cas_i[$id]['id'] = $id;
				$liste_cas_i[$id]['nb'] = $nb_c;
				$affectables[$id]['compatibles'] = $compatibles;	
			endif;			

			/** string l'élève en cours, a-t-il des affinités négatives ?*/
			$req = "select * from `incompatibles` where eleve_id_1 = $id";
			$res = $db->query  ($req);
			$incompatibles = array();
			$nb_i =0;
			while ($un_cas = $res->fetchArray()):
				$ajustements+=1;
				$incompatibles [] = $un_cas['eleve_id_2'];
			endwhile;
			$nb_i =count($incompatibles) ;
			if ($nb_i> 0):
				$liste_cas_c[$id]['id'] = $id;
				$liste_cas_c[$id]['nb'] = $nb_i;
				$affectables[$id]['incompatibles'] = $incompatibles;	
			endif;			
		endwhile;
		$requete = "select * from affectes";
		$res = $db->query($requete);
		arsort($liste_cas_c);
		arsort($liste_cas_i);	
		return array($affectables, $ajustements, $nb_a_affecter, $liste_cas_c, $liste_cas_i, $liste_cas_p);
	}
	
	
	/*
	__________
	|ajuster |
	----------
	*/
	/** 
	* \fn ajuster($db, $liste_cas_c, $liste_cas_i, $liste_cas_p)
	* \brief ajustements sur élèves à grouper, élèves à rapprocher, élèves à éloigner
	* \param $db objet sqlite
	* \param array $liste_cas_c cas compatibles
	* \param array $liste_cas_i cas incompatibles
	* \param array $liste_cas_p cas particuliers
	* \details 
	* pour chaque élève membre de la liste ayant des affinités négatives:
	* \li recherche pour chacun de ses incompatibles d'un élève ayant des choix similaires
	* \li permutation avec celui qui présente l'indice de jacquard le plus élevé si celui-ci est supoérieur au seuil choici.
	*	pour chaque élève membre de la liste ayant des affinités positives:
	* \li recherche pour chacun de ses incompatibles d'un élève ayant des choix similaires
	* \li permutation avec celui qui présente l'indice de jacquard le plus élevé si celui-ci est supoérieur au seuil choici.
	* \todo les cas particuliers
	* \return true
	*/
	function ajuster($db, $liste_cas_c, $liste_cas_i, $liste_cas_p)
	{
		global $affectables, $ratios, $visible, $seuil_jacquard;
		$candidats = $affectables;
		
		/** élèves à regrouper */
		foreach ($liste_cas_p as $un_cas) 
		{
			
		}
		
		foreach ($liste_cas_i as $un_cas) 
		{
			$id_tete = $un_cas['id'];
			$classe_tete = $affectables[$id_tete]['affectation'];
			$incompatibles = $affectables[$id_tete]['incompatibles'];
			foreach ($incompatibles as $incompatible)
			{
				$id_incompatible =$incompatible;
				$classe_incompatible = $classe_tete;
				if ($classe_incompatible == $classe_tete)
				{
					$jacquard_incompatible = $affectables[$id_incompatible]['jacquard'];
					$jacquard_max=0;
					foreach($affectables as $substitut)
					{
						$id_substitut = $substitut['id'];
						$classe_substitut = $substitut['affectation'];
						$jacquard_substitut = $substitut['jacquard'];
						$absent = in_array($id_substitut, $incompatibles);
						$jacquard = calculer_jacquard($jacquard_incompatible, $jacquard_substitut, false);
						$possible = (($classe_substitut != $classe_incompatible) and ($absent== false) and ($id_substitut != $id_incompatible));
						if ($possible)
						{
							if ($jacquard > $jacquard_max) 
							{
								$jacquard_max = $jacquard;
								$id_candidat = $id_substitut;
								$classe_candidat = $classe_substitut;
							};
						};
					}
					if ($jacquard_max > $seuil_jacquard)
					{
						$sexe_incompatible = $affectables[$id_incompatible]['sexe'];
						$sexe_candidat = $affectables[$id_candidat]['sexe'];
						$requete = "update eleves set affecte = $classe_incompatible where eleve_id = $id_candidat";
						$res = $db->exec($requete);
						$requete = "update eleves set affecte = $classe_candidat where eleve_id = $id_incompatible";
						$res = $db->exec($requete);
					};
				};
			}
		}
		foreach ($liste_cas_c as $un_cas) 
		{
			$id_tete = $un_cas['id'];
			$classe_tete = $affectables[$id_tete]['affectation'];
			$compatibles = isset($affectables[$id_tete]['compatibles']) ? $affectables[$id_tete]['compatibles']: array();
			foreach ($compatibles as $compatible)
			{
				$id_entrant =$compatible;
				$classe_entrant = $affectables[$id_entrant]['affectation'];
				if ($classe_entrant != $classe_tete)
				{
					$jacquard_entrant = $affectables[$id_entrant]['jacquard'];
					$jacquard_max=0;
					foreach($affectables as $partant)
					{
							if ($partant['affectation'] == $classe_tete)
							{
								$id_partant = $partant['id'];
								$jacquard_partant = $partant['jacquard'];
								$jacquard = calculer_jacquard ($jacquard_entrant, $jacquard_partant, false);
								if ($jacquard > $jacquard_max) 
								{
									$jacquard_max = $jacquard;
									$id_candidat = $id_partant;
								};
							};
					}
					if ($jacquard_max > $seuil_jacquard)
					{
						$sexe_entrant = $affectables[$id_entrant]['sexe'];
						$sexe_partant = $affectables[$id_partant]['sexe'];
						$requete = "update eleves set affecte = $classe_tete where eleve_id = $id_entrant";
						$res = $db->exec($requete);
						$requete = "update eleves set affecte = $classe_entrant where eleve_id = $id_partant";
						$res = $db->exec($requete);
					};
				};
			}
		}
		$visible= "hidden";
		$ajustements = 0;
		return true;
	}

	
	class MyDB extends SQLite3
	{
		function __construct($base, $passe)
		{
			try 
			{
				$this->open($base, SQLITE3_OPEN_READWRITE, $passe);
			}
			catch (Exception $e)
			{
				$this->open($base, SQLITE3_OPEN_CREATE, $passe);
			}
		}
	}
		
	/*=====================================================================
	========================================================================
	INITIALISATIONS
	========================================================================
	=======================================================================*/
	
	/** string le nom de la base de données*/
	$base = $_POST['base'];
	/** string le mot de passe de la base de données*/
	$passe = $_POST['passe'];
	$ajuster = isset($_POST['ajuster']) ? $_POST['ajuster'] : 0;
	$seuil_jacquard = isset ($_POST['seuil_jacquard']) ? $_POST['seuil_jacquard'] :1;
	$db = new MyDB($base, $passe);
	$db->close();
	$db->open($base, 0666, $passe);
	
	$filiere = isset($_POST['filiere']) ? $_POST['filiere']: "";
	$filiere = ($filiere == "sans") ?  "": $filiere;
	date_default_timezone_set('Europe/Paris');
	$les_mois= array("","janvier", "f&eacute;vrier", "mars", "avril", "mai", "juin", "juillet", "ao&ucirc;t", "septembre", "octobre", "novembre", "d&eacute;cembre");
	$les_jours = array("dimanche", "lundi", "mardi", "mercredi","jeudi", "vendredi", "samedi");
	$mois = $les_mois[date('n')];
	$mois_n = date('m');
	$jour = $les_jours[date('w')];
	$quantieme = date('j'); 
	$annee = date('Y');;
	$la_date = $jour."_".$quantieme."_".$mois."_".$annee;
	$date_raccourcie = date('j')."_".date('n');
	$visible = "hidden";
	
	/*====================================================================
	======================================================================
	LECTURE DE LA TABLE ELEVES
	======================================================================
	======================================================================*/
	$temp = lire_table($db);
	$affectables = $temp[0];
	$ajustements = $temp[1];
	$nb_individus = $temp[2];
	$nb_a_affecter = $nb_individus;
	$liste_cas_c = $temp[3];
	$liste_cas_i = $temp[4];
	$liste_cas_p = $temp[5];	

	$nb_classes = isset($_POST['nb_classes']) ? $_POST['nb_classes'] : 1;
	$seuil = isset($_POST['seuil'] ) ? $_POST['seuil'] : ceil ($nb_individus / $nb_classes);

	/*====================================================================
	======================================================================
	REPARTITION
	=======================================================================
	======================================================================*/
	/** integer $ajuster : 
	* \li 0 première passe affectation suivant les choix
	* \li 1 ajustement des compatibles, incompatibles, groupables
	*/
	if ($ajuster !=1)
	{	
	
		$criteres = array();
		/** 
		* comptage des élèves pour chaque contrainte
			* et constitution du tableau $criteres 
		* qui est orodonné par effectifs décroissants
		* en ignorant les critères d'effectif 0
		*/
		$rang =1;
		$effectif_min = 9999999999;
		$effectif_max =0;
		// pour chaque contrainte
		for ($i = 1; $i<=10; $i++)
		{
			$nom_contrainte = "contrainte_".$i;
			$requete = "select count(eleve_id) from`eleves` where $nom_contrainte  != ''";
			$resultat = $db->query ($requete);
			$ligne = $resultat ->fetchArray();
			$effectif = $ligne[0];
			if ($effectif !=0)
			{// effectif non nul
				$critere =  "contrainte_".$i;
				/* effectif de la contrainte inférieur à l'effectif minimal 
				empilage en-dessous
				sinon empilage dessus
				*/
				if ($effectif  <= $effectif_min)
				{
					array_unshift($criteres, $critere);
					$effectif_min = $effectif;
				}
				else
				{
					array_push($criteres, $critere);
				};
			}; 
		};

		/** construction de la requete de tri*/
		$requete = ($filiere != "") ? 
			"select eleve_id from`eleves`  where orientation = '$filiere' order by " :
			"select eleve_id from`eleves`  order by ";
		$rang =1;
		foreach ($criteres as $critere)
		{
			$val ="";
			if ($critere != "")
			{
				if ($rang == 1)
				{
					$val = $critere;
				}
				else
				{
					$val = ", ".$critere;	
				};
				$requete .= $val;
				$rang ++;
			};
		}
		$resultat = $db->query ($requete);
		$numero_classe = 1;
		$effectif_classe = 0;
		$resultat = $db->query ($requete);
		$numero_classe = 1;
		$effectif_classe = 0;
		while ($ligne = $resultat->fetchArray())
		{
			$id = $ligne ['eleve_id'];
			if ($effectif_classe >=$seuil)
			{
				$numero_classe ++;
				$effectif_classe=0;
			}
			else
			{
				$effectif_classe ++;
			};
			$affectables[$id]['affectation'] = $numero_classe;
			$requete = "update `eleves` set affecte = $numero_classe where (eleve_id=$id)";
			$db->exec ($requete);
		};
		/** boolean controle le menu */
		$visible = ($ajustements !=0) ? "visible": "hidden";
	}
	else
	{
		$temp = lire_table($db);
		$affectables = $temp[0];
		$ajustements = $temp[1];
		$nb_individus = $temp[2];
		$nb_a_affecter = $nb_individus;
		$liste_cas_c = $temp[3];
		$liste_cas_i = $temp[4];
		$liste_cas_p = $temp[5];	
		ajuster($db, $liste_cas_c, $liste_cas_i, $liste_cas_p);
	};

	/*====================================================================
	affichages
	======================================================================*/
	
	$nom_dir = dirname($_SERVER['SCRIPT_FILENAME'])."/bases/";
	$nom_fichier_liste = genere_nom ($date_raccourcie, ".csv", $nom_dir);
	$nom_fichier_liste = "bases/".$nom_fichier_liste;
	$ressource_fic = fopen ($nom_fichier_liste, "wb");
	if (!$ressource_fic):
		$message = identifier_erreur_sortie ($chemin_resultat);
	else:
		$message = T_NOM_FICHIER_LISTE."<b>$nom_fichier_liste</b>";
	endif;
	$ratio_global = ratio ($db);
	$chaine_csv = "$la_date";
	$chaine = "<div style='border:none;overflow:hidden'>";
	$chaine .= "<p>$la_date ".T_NOM_FICHIER_LISTE."<a href ='$nom_fichier_liste'>$nom_fichier_liste</a></p></div>
	<div class= 'ligne_absolue'style='top:23%; height:70%; font-size:10pt; border:solid thin black;overflow:scroll'>";


	for ($i = 1; $i <= $nb_classes; $i ++):
		$chiffres = ratio_classe($db, $i);
		$effectif_classe = $chiffres[1];
		$ratio_classe = $chiffres[0];	
		$chaine .= "<p>".T_CLASSE.$i." $t_effectif".$effectif_classe ." ".T_RATIO_TOTAL.$ratio_global ." ".T_RATIO_CLASSE.$ratio_classe    ;
		$chaine_csv .= "\n\n".	T_CLASSE. $i. " ".$effectif_classe." \n";
		$requete = "	select * from `eleves` as e  
			where (affecte=$i ) order by e.eleve_nom";
		$resultat = $db->query ($requete);
		$num_eleve =1;
		while ($ligne = $resultat->fetchArray()):
			$eleve_nom = $ligne['eleve_nom'];
			$eleve_prenom = $ligne['eleve_prenom'];
			$eleve_nom_d = html_entity_decode($ligne['eleve_nom'], ENT_QUOTES,"UTF-8");
			$eleve_prenom_d = html_entity_decode($ligne['eleve_prenom'], ENT_QUOTES, "UTF-8");
			$eleve_sexe = $ligne['eleve_sexe'];
			$eleve_naissance = $ligne['naissance'];
			$eleve_id = $ligne['eleve_id'];
			$choix_1 =$ligne['contrainte_1'];
			$choix_2 =$ligne['contrainte_2'];
			$choix_3 =$ligne['contrainte_3'];
			$choix_4 =$ligne['contrainte_4'];
			$choix_5 =$ligne['contrainte_5'];
			$choix_6 =$ligne['contrainte_6'];
			$choix_7 =$ligne['contrainte_7'];
			$choix_8 =$ligne['contrainte_8'];
			$choix_9 =$ligne['contrainte_9'];		
				$choix_10 =$ligne['contrainte_10'];
			$chaine .= "<br>$num_eleve: $eleve_nom $eleve_prenom $eleve_sexe $eleve_naissance \t $choix_1 $choix_2 $choix_3 $choix_4 $choix_5 $choix_6 $choix_7 $choix_8 $choix_9 $choix_10"; 
			$chaine_csv .="$eleve_id;$num_eleve; $eleve_nom_d; $eleve_prenom_d; $eleve_sexe; $eleve_naissance;$choix_1;$choix_2;$choix_3;$choix_4;$choix_5; $choix_6;$choix_7;$choix_8; $choix_9; $choix_10\n"; 
			$num_eleve++;
		endwhile;
	endfor;
	fputs ($ressource_fic, $chaine_csv);
	fclose($ressource_fic);
	/*====================================================================
	======================================================================
	MENU
	======================================================================
	======================================================================*/
print T_TITRE_INV."$chaine </div>
	<div class= 'ligne_boutons' style='top:93%;'>
		<div class = 'cellule' >
			<form method ='post' action ='menu_general.php'>
				<input type = 'hidden' name= 'base' value ='$base' />
				<input type = 'hidden' name= 'passe' value ='$passe' />
				<button type='submit'>".
				T_RETOUR_MENU."</button>
			</form>
		</div>
		<div class = 'cellule' style = 'visibility:$visible'>
			<form method ='post' action ='repartir_avec_contraintes.php'>
				<input type ='hidden' name= 'seuil' value =' $seuil' />
				<input type = 'hidden' name= 'base' value ='$base' />
				<input type = 'hidden' name= 'passe' value ='$passe' />
				<input type = 'hidden' name= 'nb_classes' value ='$nb_classes' />				
				<input type = 'hidden' name= 'ajuster' value ='1' />	
				".T_SEUIL_JACQUARD."
				<button type='submit'>".
					T_AJUSTER."</button>
			</form>
		</div>
		<div class = 'cellule'>
			<form method ='post' action = 'preciser_contraintes.php'>
			<input type = 'hidden' name= 'base' value ='$base' />
			<input type = 'hidden' name= 'passe' value ='$passe' />
			<input type = 'hidden' name ='seuil' value = '$seuil'>
			<input type = 'hidden' name ='filiere' value = '$filiere'>
			<button type = 'submit'>".	T_CHOIX_REPARTITION."</button>
			</form>
		</div>

	</div>".

	$bas_de_page
?>

</body>
</html>
