<?PHP
/**
* \file repartir_avec_particularites.php
* \ingroup Réglisse
* \version  stable
* \brief répartition en fonction des particularités des cas spécifiés
* en saisir_particularites_2.php
* \details 
* \li  regroupement irrévocable tous les élèves notés grouper 
* \li dispersion révocable de tous les élèves notés disperser
* \li affectation des élèves restants en dispersant pour chacun ceux 
* qu'il ne faut pas affecter dans la même classe
* \li Quand tout est fini, déplacement de ceux qu'il est souhaitable 
* de réunir en les permutant au mieux
* \n
*/
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="content-type" 
		content="text/html;charset=utf-8" />
	<title>Réglisse répartition avec particularités</title>
	<meta name="author" content="Billard" />
	<meta name ="keywords" content ="education, distribution of students into several classes" />
	<link rel="stylesheet" type="text/css" href="styles.css" media="screen" />


<!--
	/////////  GPL Licence - Réglisse
	
	Copyright (c) 2011, Michel Billard Sirakawa http://sibylle.ouvaton.org
 
	This file is part of Réglisse.

	Réglisse is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	Date: 15 juin 2011
	Version :Réglisse version 1
	Author : Michel Billard Sirakawa BillardMchl (at) aol (point) com
	Information site : http://sibylle.ouvaton.org
	///////////
	
	-->
	
</head>
<!-- répartition-->
<body style = 'width:98%;background-color:lavender'>
<?PHP
error_reporting (E_ALL);
include ("reglisse.inc");


/**
* \fn repartir_particuliers ($db, $nb_classes, $effectif_max)
* \brief traitement des cas particuliers
\param $db la ressource bdd sqlite
\param $nb_classes : nombre de classes
\param $effectif_max : effectif maximal d'uhe classe
\return true
* \details Traitement prioritaire sans se soucier des ratios qui
* seront redressés lors de l'affectation des autres élèves.  
* ·\li si le cas vaut 1, il s'agit d'élèves à grouper (ex: même handicap  
* physique exigeant une salle particulière, ou élèves prenant le même 
* transport en commun à horaires particuliers. La raison en clair 
* n'est stockée nulle part). 
* \n Ces élèves sont regroupés arbitrairement dans la classe 1.
* \li si le cas vaut 2, il s'agit d'élèves à disperser (même handicap 
* intellectuel, par exemple); 
* \n ils sont dispersés dans les classes 2 
* et suivantes
*/
function repartir_particuliers ($db, $nb_classes, $effectif_max)
{
	global $ratios, $affectables, $nb_a_affecter;
		$nb_particuliers =0;
		foreach ($affectables as $individu):
			$cas = $individu['cas'];
			$sexe = $individu['sexe'];
			$id = $individu['id'];
			switch ($cas)
			{
				case 1: //cas à grouper
					$nb_particuliers ++;
					$mobilite= "F";
					$effectif_1 = $ratios[1]['total'];
					if ($effectif_1 < $effectif_max):
						$classe_choisie = 1;
					else:
						$classe_choisie = 0;
						for ($i_c = 2; $i_c < $nb_classes; $i_c ++):
							$effectif = $ratios[$i_c]['total'];
							if ($effectif < $effectif_max):
								$classe_choisie = $i_c;
							endif;
						endfor;
					endif;
				break;
				case 2: // cas à disperser
					$nb_particuliers ++;
					$mobilite = "T";
					$classe_choisie = rand (1, $nb_classes);
					$effectif = $ratios[$classe_choisie]['total'];
					while ($effectif > $effectif_max):
						$classe_choisie = rand (1, $nb_classes);
						$effectif = $ratios[$classe_choisie]['total'];
					endwhile;
				break;
				default:
					$classe_choisie =0;
			}
			if ($classe_choisie !=0 ):
				$ratios[$classe_choisie][$sexe]++;
				$ratios[$classe_choisie]['total']++;
				$ratios[$classe_choisie]['ratio'] = $ratios[$classe_choisie]['M'] / $ratios[$classe_choisie]['total'];
				$affectables[$id]['affectation']=$classe_choisie;
				$nb_a_affecter --;
				$requete = "insert into `affectes` (`eleve_id`, `classe_id`, `mobile`) values ($id, $classe_choisie, '$mobilite')";
				$db->exec ($requete);
			endif;
		endforeach;
			print "<div class= 'ligne_absolue' style ='top:83%; left:5%; width:15%'>cas particuliers: $nb_particuliers </div>";
		return true;
}


/**
* \fn repartir_eleves ($db, $nb_classes, $nb_a_affecter, $effectif_max)
* \brief Identifier et placer les 	élèves non placés par repartir_particuliers
\param $db la ressource bdd sqlite
\param $nb_classes : nombre de classes
\param $effectif_max : effectif maximal d'uhe classe
\return true
* \details 
* \n la liste a été mélangée, le résultat varie d'une fois sur l'autre
* \n À chaque élève affecté, on disperse ceux qu'il faut pas affecter 
* à la même classe que lui
* 
*/
function repartir_eleves ($db, $nb_classes,  $nb_a_affecter, $effectif_max)
{
	
	global $ratios, $affectables, $table_incompatibles, $table_compatibles,
	
	$table_affectes;
	
	/** $nb_eloignements integer nombre de cas d'éloignements traités*/
	$nb_eloignements = 0;
	/** $numeros array of integer id des élèves non affectés par repartition_particuliers; 
	* il est mélangé
		*/
	$numeros = array();

	foreach ($affectables as $affectable)
	{
		 if($affectable ['affectation'] == 0):
			$numeros[] = $affectable['id'];
		 endif;
	}
	shuffle($numeros);
	/** pour chaque élève */
	foreach ($numeros as $numero)
	{
		/** $eleve_a_affecter integer $id à affecter*/
		$eleve_a_affecter = $numero;	
		/* =======================================================
		recherche d'incompatibilités de cet élève 
		*/
		$requete = "select  `eleve_id_2` from `incompatibles`  
							where ( `eleve_id_1` = $eleve_a_affecter	) ";
		$resultat_incompatibles = $db->query($requete);
		
		/** 
		* $t_clases array of integer : pour chaque classe combien d'incompatibles
		* avec $eleve_a_affecter
		*/
		$t_classes = array();
		for ($i = 1; $i <= $nb_classes; $i ++):
			$t_classes[$i]['id'] = $i;
			$t_classes[$i]['nb_incompatibles'] = 0;
		endfor;
		
		/** pour chaque élève incompatible, recherche de la classe 
		à laquelle il est peut-être affecté et incrémentation de la ligne
		correspondante de $t_classes
		*/
		/** $nb_incompatibles integer nombre d'incompatibles */
		$nb_incompatibles =0;
		
		/* parcours des résultats de la requête */
		while ($ligne = $resultat_incompatibles->fetchArray()):
			$nb_incompatibles ++;
			$incompatible = $ligne['eleve_id_2'] ;
			/*recherche de la classe où est affecté l'incompatible courant*/
			$requete_inc = "select `classe_id` from `affectes` where (`eleve_id` = $incompatible)";
			$resultat_inc = $db->query ($requete_inc);
			/* incrementation de l'effectif d'incompatibles des classes trouvées*/
			while ($ligne_inc = $resultat_inc->fetchArray()):
				$n_classe = $ligne_inc['classe_id'];
				$t_classes[$n_classe]['nb_incompatibles'] +=1;
			endwhile;
		endwhile;
		
		if ($nb_incompatibles == 0): /** si l'élève à affecter n'a pas d'incompatibles
			recherche d'équilibrage des sexes */
			$sexe = $affectables[$eleve_a_affecter]['sexe' ];
			$ratio_min= 9999;
			$classe_choisie = rand(1, $nb_classes);
			if ($sexe =="M"): 
				/** si le sexe est m, on affecte à la classe qui a le ratio m/total 
				le plus faible
				*/
				for ($ncl = 1; $ncl <= $nb_classes; $ncl++):
					$ratio_ncl = $ratios[$ncl]['ratio'];
					$effectif_cl = $ratios[$ncl]['total'];
					if  ($effectif_cl < $effectif_max):
						if ($ratio_ncl < $ratio_min):
							$ratio_min = $ratio_ncl;
							$classe_choisie = $ncl;
						endif;
					endif;
				endfor;
			else:
				/** si le sexe est f, on affecte à la classe qui a le ratio m/total 
				le plus fort
				*/
				$ratio_max= 0;
				$classe_choisie = rand(1, $nb_classes);
				for ($ncl = 1; $ncl <= $nb_classes; $ncl++):
					$ratio_ncl = $ratios[$ncl]['ratio'];
					$effectif_cl = $ratios[$ncl]['total'];
					if  ($effectif_cl < $effectif_max):
						if ($ratio_ncl > $ratio_max):
							$ratio_max = $ratio_ncl;
							$classe_choisie = $ncl;
						endif;
					endif;
				endfor;
			endif;
			$requete = "INSERT into `affectes` (`eleve_id`, `classe_id`) values ($eleve_a_affecter, $classe_choisie)";
			$db->exec ($requete);
			$affectables[$eleve_a_affecter]['affectation'] = $classe_choisie;
			$ratios[$classe_choisie][$sexe] +=1;
			$ratios[$classe_choisie]['total'] +=1;
			$ratios[$classe_choisie]['ratio'] =$ratios[$classe_choisie]['M'] / $ratios[$classe_choisie]['total'];
			$nb_a_affecter --;
		else: /** s'il y a des incompatibilités
			recherche de la classe la moins chargée en incompatibles*/
			$classe_choisie = rand(1, $nb_classes); 
			$min_exclus = $t_classes[$classe_choisie]['nb_incompatibles'];
			foreach ($t_classes as $classe)
			{
				$nb_exclus_classe = $classe['nb_incompatibles'];
				if ($nb_exclus_classe < $min_exclus):
					$min_exclus = $nb_exclus_classe;
					$classe_choisie = $classe['id'];
				endif;
			}
			$requete = "INSERT into `affectes` (`eleve_id`, `classe_id`, `mobile`) values ($eleve_a_affecter, $classe_choisie, 'F')";
			$db->exec ($requete);
			$affectables[$eleve_a_affecter]['affectation'] = $classe_choisie;
			$ratios[$classe_choisie][$sexe] +=1;
			$ratios[$classe_choisie]['total'] +=1;
			$ratios[$classe_choisie]['ratio'] =$ratios[$classe_choisie]['M'] / $ratios[$classe_choisie]['total'];
			$nb_a_affecter --;
			$nb_eloignements ++;
		endif;
	}
	print "<div class= 'ligne_absolue' style ='top:83%; width:15%; left:15%;'> éloignements: $nb_eloignements</div>";
	return true;
}

/**
* \fn ajuster ($db)
* \brief Rapprocher les affinités positives
\param $db la ressource bdd sqlite
\return true
* \details 
* pour chaque élève, s'il possède des affinités positives, 
* on les met dans sa classe en les permutant avec d'autres, de même sexe si possible.
* 
*/

function ajuster ($db)
{
	global $affectables, $ratios;
	$rapprochements = 0;
	$requete_el = "select * from `affectes`";
	$resultat_el = $db->query ($requete_el);
	/** pour chaque élève*/
	while ($ligne_el = $resultat_el->fetchArray()):
		/**$eleve_tete id de l'élève qui attire*/
		$eleve_tete = $ligne_el['eleve_id'];
		
		/** $classe_tete  id de la classe de l'élève qui attire*/
		$classe_tete = $ligne_el['classe_id'];
		
		/** identification de ceux qu'on peut rapprocher */
		$requete_co = "select * from `compatibles` where (`eleve_id_1` = $eleve_tete)";
		$resultat_co = $db->query ($requete_co);
		while ($ligne_co = $resultat_co->fetchArray()):
			/** $eleve_suiveur id d'un élève à rapprocher de eleve_tete*/
			$eleve_suiveur = intval($ligne_co['eleve_id_2']);
			
			/** $classe_suiveur id de la classe de $eleve_suiveur */
			$classe_suiveur = $affectables[$eleve_suiveur]['affectation'];
			/** $sexe_suiveur sexe de $eleve_suiveur */
			$sexe_suiveur = $affectables[$eleve_suiveur]['sexe'];	
			
			if ($classe_tete != $classe_suiveur):/** si les deux classes sont différentes
			on cherche les eleves de la classe de eleve_tete qui peuvent bouger <i>sans</i>
			tenir compte du sexe*/
				$requete_mobile = "select * from `affectes` where `classe_id` = $classe_tete and `mobile`='T' ";
				$id_mobile = $db->query($requete_mobile);
				$sexe_bouge = "";
				$id_bouge_final = 0;
				$classe_origine_bouge = $classe_tete;
				$classe_destination_bouge =$classe_suiveur;
				/** on cherche un eleve du meme sexe qui peut bouger, sinon on prendra dans l'autre sexe*/
				while ($bouge = $id_mobile->fetchArray()):
					$id_bouge = $bouge['eleve_id'];
					$sexe_bouge = $affectables[$id_bouge]['sexe'];
					if ($sexe_bouge == $sexe_suiveur):
						$id_bouge_final = $id_bouge;
					endif;
				endwhile;
				//reglage des ratios
				// la classe que quitte le suiveur
				$ratios[$classe_suiveur][$sexe_suiveur] -=1;
				$ratios[$classe_suiveur]['total'] -=1;
				$ratios[$classe_suiveur]['ratio'] =$ratios[$classe_suiveur]['M'] / $ratios[$classe_suiveur]['total'];
				//la classe qui reçoit le suiveur
				$ratios[$classe_tete][$sexe_suiveur] +=1;
				$ratios[$classe_tete]['total'] +=1;
				$ratios[$classe_tete]['ratio'] =$ratios[$classe_tete]['M'] / $ratios[$classe_tete]['total'];
				
				// la classe que quitte le bouge
				$ratios[$classe_origine_bouge][$sexe_bouge] -=1;
				$ratios[$classe_origine_bouge]['total'] -=1;
				$ratios[$classe_origine_bouge]['ratio'] =$ratios[$classe_origine_bouge]['M'] / $ratios[$classe_origine_bouge]['total'];
				// la classe que rejoint le bouge
				$ratios[$classe_suiveur][$sexe_bouge] +=1;
				$ratios[$classe_suiveur]['total'] +=1;
				$ratios[$classe_suiveur]['ratio'] =$ratios[$classe_suiveur]['M'] / $ratios[$classe_suiveur]['total'];
				
// mise à jour de affectes
		$requete_1 = "Update `affectes` set `classe_id` = $classe_suiveur where `eleve_id` = $id_bouge_final";
			$db->exec ($requete_1);
			$requete_1 = "Update affectes set classe_id = $classe_tete where eleve_id = $eleve_suiveur";
			$db->exec ($requete_1);
			$rapprochements ++;
	endif;
		endwhile;
	endwhile;
				print "<div class= 'ligne_absolue' style ='top:83%; width:15%;left:25%'>rapprochements: $rapprochements </div>";

}
/*========================================================================*/

error_reporting(0);
/* ouverture de la table*/
	/** string la base de données*/
	$base = $_POST['base'];
	/** string le mot de passe de la base de données */
	$passe = $_POST['passe'];	
	class MyDB extends SQLite3
	{
		function __construct($base, $passe)
		{
			try 
			{
				$this->open($base, SQLITE3_OPEN_READWRITE, $passe);
			}
			catch (Exception $e)
			{
				$this->open($base, SQLITE3_OPEN_CREATE, $passe);
			}
		}
	}

	/*========================================================================
	==========================================================================
	*/
	/** objet sqlite*/
	$db = new MyDB ($base, $passe);

	/** integer nombre de classes */
	$nb_classes = isset($_POST['nb_classes']) ? $_POST['nb_classes'] : -1;
	if ($nb_classes <= 0 ):
		print "<html>
			<head>
				<META HTTP-EQUIV='Refresh' CONTENT='60; URL=index.php'>
			<head>
			<'id']; style='background-color:lavender'>
				<div>".T_TITRE_1."
					<form method ='post' action ='index.php'>
						".T_NOMBRE_DE_CLASSES_ABSENT."
					<button type = 'submit'>$suite</button>
					</form>
				</div>
			</body>
		</html>";		
	endif;

	/** le nom du ficihier de sauvegarde*/
	date_default_timezone_set('Europe/Paris');
	$les_mois= array("","janvier", "f&eacute;vrier", "mars", "avril", "mai", "juin", "juillet", "ao&ucirc;t", "septembre", "octobre", "novembre", "d&eacute;cembre");
	$les_jours = array("dimanche", "lundi", "mardi", "mercredi","jeudi", "vendredi", "samedi");
	$mois = $les_mois[date('n')];
	$mois_n = date('m');
	$jour = $les_jours[date('w')];
	$quantieme = date('j'); 
	$annee = date('Y');;
	$la_date = $jour."_".$quantieme."_".$mois."_".$annee;
	$date_raccourcie = date('j')."_".date('n');
	$cr =" ";

	/** string réinitialisation de la table des affectations */
	$requete = "delete from `affectes`; ";
	$db->exec ($requete);

	/** string consultation de la table des élèves*/
	$requete = "select * from `eleves`";
	$resultat_liste = $db->query ($requete);

	/** 
	* array  des affectations des élèves indicé par l'id de l'élève
	* \li $affectables[$id]['id'] = $id;
	* \li $affectables[$id]['sexe'] = $sexe;
	* \li	$affectables[$id]['affectation'] = 0;
	* \li	$affectables[$id]['nom'] = $nom;
	* \li		$affectables[$id]['cas']= $cas; cas particuliers
	*/
	$affectables = array();

	/** 
	* integer nombre d'élèves à affecter 
	*/
	$nb_a_affecter = 0;
	
	/** integer nombre de masculins*/
	$nb_m= 0;
	
	/** pour toutes les lignes de la table eleves*/
	while ($ligne = $resultat_liste->fetchArray()):
		$id = $ligne['eleve_id'];
		$sexe = $ligne['eleve_sexe'];	
		$nom = $ligne ['eleve_nom'];
		$affectables[$id]['id'] = $id;
		$affectables[$id]['sexe'] = $sexe;
		$affectables[$id]['affectation'] = 0;
		$affectables[$id]['nom'] = $nom;
		$nb_a_affecter ++;
		$nb_m += ($sexe == 'M') ? 1 :0;
		
		/** string  pour l'élève en cours, est-il un cas particulier ?*/
		$req = "select * from `particuliers` where eleve_id = $id";
		$res = $db->query  ($req);
		if ($ligne = $res ->fetchArray()):
			$cas = $ligne['eleve_cas'];
			$affectables[$id]['cas']= $cas;
		else:
			$affectables[$id]['cas'] = 0;
		endif;
	endwhile;
	/** float rapport m/population */
	$ratio_general = $nb_m / $nb_a_affecter;


	/** 
	* array renseignements sur les classes indicé par le numéro de classe
	* \details
	*\li $ratios[$i]['M']= 0; nombre de m de la classe
	* \li $ratios[$i]['ratio'] = 0; rapport m/total de la classe
	* \li	$ratios[$i]['total'] = 0; nombre d'élèves de la classe
	*	$ratios[$i]['membres'] = ""; $id des membres de la classe
	*/
	$ratios = array();
	for ($i = 1; $i <= $nb_classes; $i++):
		$ratios[$i]['M']= 0;
		$ratios[$i]['F'] = 0;
		$ratios[$i]['ratio'] = 0;
		$ratios[$i]['total'] = 0;
		$ratios[$i]['membres'] = "";
	endfor;
	
	/** integer effectif maximal d'une classe*/
	$effectif_max = ceil ($nb_a_affecter / $nb_classes);

	repartir_particuliers ($db, $nb_classes, $effectif_max);
	repartir_eleves ($db, $nb_classes,  $nb_a_affecter, $effectif_max);
	ajuster ($db);

	/** string nom du fichier résultat au format csv*/
	$nom_fichier_liste = "bases/".genere_nom ($date_raccourcie, ".csv", "");
	$ressource_fic = fopen ($nom_fichier_liste, "wb");
	if (!$ressource_fic):
		$message = identifier_erreur_sortie ($chemin_resultat);
	else:
		$message = T_NOM_FICHIER_LISTE."<b>$nom_fichier_liste</b>";
	endif;
	/** string la chaine du fichier csv*/
	$chaine_csv = "$la_date";
	$chaine = "<div class= 'ligne_absolue' style='top:0%; border:none;overflow:hidden'>";
	/** string la chaine du résultat à l'écran */
	$chaine .= "<p>$la_date ".T_NOM_FICHIER_LISTE."<a href ='$nom_fichier_liste'>$nom_fichier_liste</a></p></div>
	<div class= 'ligne_absolue' style='top:7%; height:75%; font-size:10pt; border:solid thin black;overflow:scroll'>";

	/** constitution des deux chaines*/
	for ($i = 1; $i <= $nb_classes; $i ++):
		$effectif_classe = $ratios[$i]['total'];
		$effectif_M_classe = $ratios[$i]['M'];
		$effectif_F_classe = $ratios[$i]['F'];
		$ratio_classe = round($ratios[$i]['ratio'],2);
		$ratio_general = round ($ratio_general,2);
		$chaine_csv .= "\n\n".	T_CLASSE." $i; ".T_EFFECTIF_CLASSE." $effectif_classe; ".
		T_MASCULINS." $effectif_M_classe; ".T_FEMININS." $effectif_F_classe;".
		T_RATIO_CLASSE." $ratio_classe;".T_RATIO_TOTAL." $ratio_general;\n";
		$chaine .= "<p><b>".T_CLASSE	." $i</b></p><p>".T_EFFECTIF_CLASSE."$effectif_classe:
		".T_MASCULINS." $effectif_M_classe, ".T_FEMININS." $effectif_F_classe. ".
		T_RATIO_CLASSE."$ratio_classe.". T_RATIO_TOTAL." $ratio_general</p>";
		$requete = "
			select * from `affectes` as a, `eleves` as e  
			where (classe_id=$i and a.eleve_id = e.eleve_id and a.classe_id !=0) order by e.eleve_nom";
		$resultat = $db->query ($requete);
		$num_eleve =1;
		while ($ligne = $resultat->fetchArray()):
			$eleve_id =$ligne['eleve_id'];
			$eleve_nom = $ligne['eleve_nom'];
			$eleve_prenom = $ligne['eleve_prenom'];
			$eleve_sexe = $ligne['eleve_sexe'];
			$eleve_naissance = $ligne['naissance'];
			$contraintes = array();
			$contraintes[] = $ligne['contrainte_1'];
			$contraintes[]= $ligne['contrainte_2'];			
			$contraintes[] = $ligne['contrainte_3'];			
			$contraintes[] = $ligne['contrainte_4'];			
			$contraintes[] = $ligne['contrainte_5'];			
			$contraintes[] = $ligne['contrainte_6'];			
			$contraintes[] = $ligne['contrainte_7'];			
			$contraintes[] = $ligne['contrainte_8'];			
			$contraintes[]= $ligne['contrainte_9'];			
			$contraintes[] = $ligne['contrainte_10'];			
			$contraintes_ecran = implode (" ", $contraintes);
			$contraintes_csv = implode ("; ", $contraintes);			
			$chaine .= "<br />$num_eleve: $eleve_nom $eleve_prenom $eleve_sexe $eleve_naissance $contraintes_ecran<br />"; 
			$chaine_csv .=html_entity_decode("$eleve_id;$num_eleve; $eleve_nom; $eleve_prenom;$eleve_sexe; $eleve_naissance; $contraintes_csv",ENT_QUOTES, "UTF-8")."\n"; 
			$num_eleve++;
		endwhile;
	endfor;
	$chaine .="</div>

	<div class = 'ligne_absolue' style='top:83%; left:45%;border:none'>
		<div class = 'cellule' style ='border: medium black inset '>
			<form method = 'post' action = 'menu_general.php'>
			<p>
				<input type = 'hidden' size ='3' name = 'nb_classes' value = '$nb_classes' />
				<input type = 'hidden' size ='3' name = 'passe' value = '$passe' />
						<input type = 'hidden' size ='3' name = 'base' value = '$base' />		
			
				<button type= 'submit'>".T_RETOUR_MENU."</button>
				</p>
			</form>
			
		</div>
		<div class = 'cellule' style ='border: medium black inset '>
			<form method = 'post' action = 'repartir_avec_particularites.php'>
			<p>
				<input type = 'text' size ='3' name = 'nb_classes' value = '$nb_classes' />
				<input type = 'hidden' size ='3' name = 'passe' value = '$passe' />
				<input type = 'hidden' size ='3' name = 'base' value = '$base' />
				<button type = 'submit'>".T_AUTRE_REPARTITION."</button>
				</p>
			</form>
		</div>
	</div>
		";
	print "$chaine $bas_de_page_1

	</body>
</html>";
	$ressource_fic = fopen ($nom_fichier_liste, "wb");
	fputs ($ressource_fic, $chaine_csv);
	close ($ressource_fic);
?>
