<?PHP
/**
* \file repartition_libre.php
* \ingroup Réglisse
* \version  stable
* \brief répartition libre sans aucune contrainte
* \details 
*/
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta name="generator" content="HTML Tidy for Linux (vers 6 November 2007), see www.w3.org" />
<meta http-equiv='Content-Type' content='text/html; charset=utf-8' />
<title>Réglisse répartition libre+</title>
<meta name="author" content="Billard" />
<meta name="keywords" content="education, distribution of students into several classes" />
<link rel="stylesheet" href="styles.css" type="text/css" /><!--
        /////////  GPL Licence - Cohortes
        
        Copyright (c) 2011, Michel Billard Sirakawa http://sibylle.ouvaton.org
 
        This file is part of cohortes.

        Cohortes is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program.  If not, see <http://www.gnu.org/licenses/>.
        
        Date: 15 juin 2011
        Version :Cohortes version 1
        Author : Michel Billard Sirakawa BillardMchl (at) aol (point) com
        Information site : http://sibylle.ouvaton.org
        ///////////
        
        -->
</head>
<!-- répartition-->
<body style = 'width:98%;background-color:lavender'>
<?PHP
	include ("reglisse.inc");

	/** 
	* \fn remplissage_affectables ($db) 
	* \brief remplit le tableau affectables
	* \param $db la ressource
	* \details
	* remplit affectables array  des affectations des élèves indicé par l'id de l'élève
	* \li $affectables[$id]['id'] = $id;
	* \li $affectables[$id]['sexe'] = $sexe;
	* \li	$affectables[$id]['affectation'] = 0;
	* \li	$affectables[$id]['nom'] = $nom;
	* \li		$affectables[$id]['cas']= $cas; cas particuliers
	* return true
	*/
	function remplissage_affectables ($db)
	{
		global $affectables;
		$requete = "select *  from `eleves`";
		$resultat = $db->query ($requete);
		$id =1;
		while ($ligne = $resultat->fetchArray()):
			$id = $ligne['eleve_id'];
			$sexe = $ligne['eleve_sexe'];	
			$affecte = $ligne['affecte'];	
			$nom = $ligne ['eleve_nom'];
			$affectables[$id]['id'] = $id;
			$affectables[$id]['sexe'] = $sexe;
			$affectables[$id]['affectation'] = 0;
			$affectables[$id]['nom'] = $nom;
		endwhile;
		
	return true;
		
	}


	/** 

	* \param $db la ressource BDD
	* \param $nb_classes : integer nombre de classes
	* \param $ratio_general : float ratoi m/total de la population
	* \param $nb_a_affecter integer nombre d'individus à affecter
	* \details
	* \n tirage au sort d'un individu
	* \n le sexe de l'élève à choisir détermine la classe où on l'affecte
	* \li si c'est un m, la classe choisie est celle dont le ration m/effectif de la classe est le plus faible.
	* \li si c'est un rf, la classe choisie est celle dont le ration m/effectif de la classe est le plus fort.
	*  \return true
	*/
	function repartir_classes ($db, $nb_classes, $ratio_general,  $nb_a_affecter)
	{
		
		global $ratios, $affectables, $db;
		$effectif = $nb_a_affecter;
		$effectif_max = ceil ($nb_a_affecter / $nb_classes);
		while ($nb_a_affecter > 0):
			$rang_choisi = rand(1, $effectif_max);
			while ($affectables[$rang_choisi]['affectation'] !=0):
				$rang_choisi = rand(1, $effectif);
			endwhile;
			$nom = $affectables[$rang_choisi]['nom'];
			$sexe = $affectables[$rang_choisi]['sexe'];
			if ($sexe == 'M'):
				// si on doit placer un masculin 
				$ratio_min =1;
				for ($i = 1;  $i <= $nb_classes; $i ++):
					$effectif_classe = $ratios[$i]['total'];
					if ($effectif_classe < $effectif_max):
						$ratio_classe = $ratios[$i]['ratio'];
						if ($ratio_classe < $ratio_min):
							$ratio_min = $ratio_classe;
							$classe_choisie = $i;
						endif;
					endif;
				endfor;
			else:
				$ratio_max =0;
				// si on doit placer un féminin
				$classe_choisie =1;
				for ($i = 1;  $i <= $nb_classes; $i ++):
					$effectif_classe = $ratios[$i]['total'];
					if ($effectif_classe < $effectif_max):
						$ratio_classe = $ratios[$i]['ratio'];
						if ($ratio_classe > $ratio_max):
							$ratio_max = $ratio_classe;
							$classe_choisie = $i;
						endif;
					endif;
				endfor;
			endif;
			$ratios[$classe_choisie][$sexe]+=1;
			$ratios[$classe_choisie]['total'] +=1;
			$ratios[$classe_choisie]['ratio'] = $ratios[$classe_choisie]['M'] / $ratios[$classe_choisie]['total'] ;
			$affectables[$rang_choisi]['affectation'] = $classe_choisie;
			$nb_a_affecter --;
			$requete ="insert into `affectes` 
			(
				eleve_id,
				classe_id
			)
			values
			(
				$rang_choisi,
				$classe_choisie
			)		";
			$resultat = $db->exec($requete);
		endwhile;	
		return true;
	}

	/*========================================================================*/

	error_reporting(E_ALL);
	/* ouverture de la table*/

	$nb_classes = isset($_POST['nb_classes']) ? $_POST['nb_classes'] : -1;
	if ($nb_classes <= 0):
		print "<html>
			<head>
				<META HTTP-EQUIV='Refresh' CONTENT='60; URL=index.php'>
			<head>
			<body style='background-color:lavender'>
				<div>".T_TITRE_1."
					<form method ='post' action ='index.php'>
						".B_NOMBRE_DE_CLASSES_ABSENT."
					</form>
				</div>
			</body>
		</html>";		
		die();
	endif;

	class MyDB extends SQLite3
	{
		function __construct($base, $passe)
		{
			try 
			{
				$this->open($base, SQLITE3_OPEN_READWRITE, $passe);
			}
			catch (Exception $e)
			{
				$this->open($base, SQLITE3_OPEN_CREATE, $passe);
			}
		}
	}

	date_default_timezone_set('Europe/Paris');
	$les_mois= array("","janvier", "f&eacute;vrier", "mars", "avril", "mai", "juin", "juillet", "ao&ucirc;t", "septembre", "octobre", "novembre", "d&eacute;cembre");
	$les_jours = array("dimanche", "lundi", "mardi", "mercredi","jeudi", "vendredi", "samedi");
	$mois = $les_mois[date('n')];
	$mois_n = date('m');
	$jour = $les_jours[date('w')];
	$quantieme = date('j'); 
	$annee = date('Y');;
	$la_date = $jour."_".$quantieme."_".$mois."_".$annee;
	$date_raccourcie = date('j')."_".date('n');
	$cr =" ";
	$base = $_POST['base'];
	$passe = $_POST['passe'];

	/* consultation de la table des élèves*/
	$db = new MyDB($base, $passe);
	$db->close();
	$db->open($base, 0666, $passe);
	$requete = "select count (eleve_id) from `eleves` where eleve_sexe ='M';";
	$resultat = $db->query ($requete);
	 $valeurs = $resultat->fetchArray(); // 42
    

	$nb_m = $valeurs [0];
	$requete = "select count(eleve_id)  from `eleves`";
	$resultat = $db->query ($requete);
	$valeurs = $resultat ->fetchArray(); 
	$nb_a_affecter = $valeurs[0];
	if ($nb_a_affecter < $nb_classes):
		print "<html>
			<head>
				<META HTTP-EQUIV='Refresh' CONTENT='60; URL=index.php'>
			<head>
			<body style='background-color:lavender'>
				<div>$titre_1
					<form method ='post' action ='index.php'>".
						T_EFFECTIF_INSUFFISANT."
					<button type = 'submit'>$suite</button>
					</form>
				</div>
			</body>
		</html>";		
		die();
	endif;
	$ratio_general = $nb_m / $nb_a_affecter;
	/** 
	* array  des affectations des élèves indicé par l'id de l'élève
	* \li $affectables[$id]['id'] = $id;
	* \li $affectables[$id]['sexe'] = $sexe;
	* \li	$affectables[$id]['affectation'] = 0;
	* \li	$affectables[$id]['nom'] = $nom;
	* \li		$affectables[$id]['cas']= $cas; cas particuliers
	*/
	$affectables = array();

	/*remplissage du tableau des élèves : $affectables */
	remplissage_affectables ($db);

	/** 
	* array renseignements sur les classes indicé par le numéro de classe
	* \details
	*\li $ratios[$i]['M']= 0; nombre de m de la classe
	* \li $ratios[$i]['ratio'] = 0; rapport m/total de la classe
	* \li	$ratios[$i]['total'] = 0; nombre d'élèves de la classe
	*	$ratios[$i]['membres'] = ""; $id des membres de la classe
	*/
	$ratios = array();
	for ($i = 1; $i <= $nb_classes; $i++):
		$ratios[$i]['M']= 0;
		$ratios[$i]['F'] = 0;
		$ratios[$i]['ratio'] = 0;
		$ratios[$i]['total'] = 0;
		$ratios[$i]['membres'] = "";
	endfor;

	$requete = "delete  from `affectes`; ";
	$db->exec ($requete);
	repartir_classes ($db, $nb_classes, $ratio_general,$nb_a_affecter);
	for ($i =1;$i <= $nb_classes;$i++):
		$nb_m = $ratios[$i]['M'];
		$nb_f = $ratios[$i]['F'];
		$total = $ratios[$i]['total'];
		$ratio = $ratios[$i]['ratio'];
	endfor;
	$chemin_resultat = "/home/bilou";
	$nom_dir = dirname($_SERVER['SCRIPT_FILENAME'])."/bases/";
	$nom_fichier_liste = genere_nom ($date_raccourcie, ".csv", $nom_dir);
	$nom_fichier_liste = "bases/".$nom_fichier_liste;

	$chaine_csv = "$la_date";
	$chaine = "<div class= 'ligne_absolue' style='top:1%; height:15%; border:none;overflow:hidden'>";
	$chaine .= "<p>$la_date </p><p>".T_NOM_FICHIER_LISTE."<a href ='$nom_fichier_liste'>$nom_fichier_liste</a></p></div>
	<div class= 'ligne_absolue' style='top:15%; height:72%; font-size:10pt; border:solid thin black;overflow:scroll'>";
	for ($i = 1; $i <= $nb_classes; $i ++):
		$effectif_classe = $ratios[$i]['total'];
		$effectif_M_classe = $ratios[$i]['M'];
		$effectif_F_classe = $ratios[$i]['F'];
		$ratio_classe = round($ratios[$i]['ratio'],2);
		$ratio_general = round ($ratio_general,2);
		$chaine_csv .= "\n\n".	T_CLASSE." $i; ".T_EFFECTIF_CLASSE." $effectif_classe; ".
		T_MASCULINS." $effectif_M_classe; ".T_FEMININS." $effectif_F_classe;".
		T_RATIO_CLASSE." $ratio_classe;".T_RATIO_TOTAL." $ratio_general;\n";
		$chaine .= "<p><b>".T_CLASSE	." $i</b><br />".T_EFFECTIF_CLASSE."$effectif_classe:
		".T_MASCULINS." $effectif_M_classe, ".T_FEMININS." $effectif_F_classe. ".
		T_RATIO_CLASSE."$ratio_classe.". T_RATIO_TOTAL." $ratio_general";
		$requete = "
			select * from `affectes` as a, `eleves` as e  
			where (classe_id=$i and a.eleve_id = e.eleve_id) order by e.eleve_nom";
		$resultat = $db->query ($requete);
		$num_eleve =1;
		while ($ligne = $resultat->fetchArray()):
			$eleve_nom = $ligne['eleve_nom'];
			$eleve_sexe = $ligne['eleve_sexe'];
			$eleve_naissance = $ligne['naissance'];
			$contraintes = array();
			$contraintes[] = $ligne['contrainte_1'];
			$contraintes[]= $ligne['contrainte_2'];			
			$contraintes[] = $ligne['contrainte_3'];			
			$contraintes[] = $ligne['contrainte_4'];			
			$contraintes[] = $ligne['contrainte_5'];			
			$contraintes[] = $ligne['contrainte_6'];			
			$contraintes[] = $ligne['contrainte_7'];			
			$contraintes[] = $ligne['contrainte_8'];			
			$contraintes[]= $ligne['contrainte_9'];			
			$contraintes[] = $ligne['contrainte_10'];			
			$contraintes_ecran = implode (" ", $contraintes);
			$contraintes_csv = implode ("; ", $contraintes);			

			$chaine .= "<br />$num_eleve: $eleve_nom $eleve_sexe $eleve_naissance $contraintes_ecran"; 
			$chaine_csv .=html_entity_decode("$num_eleve; $eleve_nom; $eleve_sexe; $eleve_naissance; $contraintes_csv",ENT_QUOTES, "UTF-8")."\n"; 
			$num_eleve++;
		endwhile;
		$chaine .= "</p>";
	endfor;
	$chaine .="</div>
	<div class = 'ligne_absolue' style='top:87%; left:40%;border:none'>

		<div class = 'cellule' style ='border: medium black inset '>
			<form method = 'post' action = 'menu_general.php'>
						<input type = 'hidden' name = 'base' value ='$base' />
					<input type = 'hidden' name = 'passe' value ='$passe' />
					<button type= 'submit'>".T_RETOUR_MENU."</button>
			</form>
		</div>
		<div class = 'cellule' style ='border: medium black inset '>
			<form method = 'post' action = 'repartition_libre.php'>
					<input type = 'text' name = 'nb_classes' value = '$nb_classes' /> 
					<input type = 'hidden' name = 'base' value ='$base' />
					<input type = 'hidden' name = 'passe' value ='$passe' />
					<button type='submit'>".T_AUTRE_REPARTITION."</button>
			</form>
		</div>

	</div>
		
		";
	print "$chaine $bas_de_page_1";
	$ressource_fic = fopen ($nom_fichier_liste, "wb");
	fputs ($ressource_fic, $chaine_csv);
	fclose ($ressource_fic);
?>
</body>
</html>
