<?PHP
/**
* \file saisir_particularites.php
* \ingroup Réglisse
* \brief identification des cas présentant des particularités
* \version  stable
* \details sélection des individus présentant des particularités
* <ol>
* 	<li>particularités recommandées</li>
			<ol>
				<li>affinités positives</li>
				<li>affinités négatives</li>
			</ol>
		<li>particularités comminatoires</li>
			<ol>
				<li>élèves à grouper</li>
				<li>élèves à disperser</li>
			</ol>
* </ol>
*/
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"> 
<head>
<meta http-equiv="content-type" 
		content="text/html;charset=utf-8" />
	<title>Réglisse saisie des particularités 1</title>
	<meta name="author" content="Billard" />
	<meta name ="keywords" content ="education, distribution of students into several classes" />
	<link rel="stylesheet" type="text/css" href="styles.css" media="screen" />

<!--
	/////////  GPL Licence - Réglisse
	
	Copyright (c) 2011, Michel Billard Sirakawa http://sibylle.ouvaton.org
 
	This file is part of Réglisse.

	Réglisse is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	Date: 15 juin 2011
	Version :Réglisse version 1
	Author : Michel Billard Sirakawa BillardMchl (at) aol (point) com
	Information site : http://sibylle.ouvaton.org
	///////////
	
	-->
	
</head>
<!-- Lecture du fichier des éléves-->


<body style = 'background-color:lavender'>
<?PHP
	include ("reglisse.inc");
	error_reporting(0);
	/** string nom de la base de données*/
	$base = $_POST['base'];
	/** mot de passe de la base de données*/
	$passe = $_POST['passe'];	
	class MyDB extends SQLite3
	{
		function __construct($base, $passe)
		{
			try 
			{
				$this->open($base, SQLITE3_OPEN_READWRITE, $passe);
			}
			catch (Exception $e)
			{
				$this->open($base, SQLITE3_OPEN_CREATE, $passe);
			}
		}
	}

	/** objet Sqlite*/
	$db = new MyDB($base, $passe);
//	$db->open($base, 0666, $passe);
	

	/** 
	* Consultation des tables compatibles et incompatibles pour
	* identifier ceux pour qui des affinités ont déjà été saisies.
	*/
	$requete ="select eleve_id  from `eleves` as el where 
		( 
			el.eleve_id in (select eleve_id_1 from `compatibles`) 
			or el.eleve_id in (select eleve_id_1 from `incompatibles`)
		);";
		/** array des  élèves pour qui des affinités ont déjà été saisies*/
	$deja_saisis = array();
	$resultat = $db->query ($requete);
	while ($ligne = $resultat->fetchArray()):
		$deja_saisis[] = $ligne['eleve_id'];
	endwhile;
	/**
	* consultation de la table des élèves pour créer:
	* \li la liste des élèves avec leur identifiant dans Mysql 
	* (ils sont céés automatiquement.)
	* \li la liste des éléments du select permettant de choisirceux pour qui 
	* on veut saisir affinités et exclusions.
	* Si des affinités ont déjà été saisies, les élèves concernés sont 
	* préselectionnés dans la liste et les choix faits pour eux apparaitront 
	* dans saisir_particularites_2.PHP.
	* Les value des éléments du select ont la forme id:nom
	*/
	$resultat = $db->query ("select * from `eleves` order by eleve_nom");
	/** string chaine html de sélection des cas particuliers sera affichée en fenêtre de droite*/
	$particuliers = "<select name = 'particuliers[]' multiple size= '30'>";
	/** integer effectif de la population */
	$nb_individus = 0;
	while ($ligne = $resultat->fetchArray()):
		$nb_individus++;
		/** string*/
		$nom = $ligne['eleve_nom'];
		/** string*/
		$prenom = $ligne['eleve_prenom'];	
		/** integer l'identificateur du cas $nom $prenom*/
		$id = $ligne['eleve_id'];
		/** string pour les cas qui ont déjà fait l'objet d'une saisie de particularités*/
		$selected = in_array($id, $deja_saisis) ? "selected": "";
		$particuliers .= "<option $selected value ='$id:$nom'>$nom $prenom</option>";
	endwhile;
	$particuliers .= "</select>";
	/** string*/
	$chaine = 
		"<div class = 'ligne_absolue' 
			style = 'border:none'>".
			T_TITRE_1."
		</div>
		<div class = 'ligne_absolue' 
			style = 'top:12%; width:50%;height:80%;border:none; overflow:auto'>".
			T_CONSIGNE_PARTICULARITES."
		</div>
		<div class = 'ligne_absolue' style= 'top:12%;left:52%;width:48%;border:none'>
		
			<form method = 'post' action ='saisir_particularites_2.php'>
			<input type = 'hidden' name='base' value ='$base'>
			<input type = 'hidden' name='passe' value ='$passe'>
			<input type = 'hidden' name='nb_individus' value ='$nb_individus'>
			$particuliers
			<button type= 'submit'>".T_PRECISER."</button>
			</form>
		</div>
		$bas_de_page";
	print "
	$chaine";
?>
</body>
</html>