<?PHP
/**
* \file saisir_particularites_2.php
* \ingroup Réglisse
* \version  stable
* \brief saisie du détail des particularités des cas sélectionnés en saisir_particularites.php
* \details 
* \li avec : il est souhaitable de réunir l'individu sélectionné avec ceux qui sont notés avec
* \li sans : il est souhaitable de ne pas réunir l'individu sélectionné avec ceux qui sont notés sans
* \n
* \li grouper : il faut regrouper tous les élèves notés grouper (prioritaire sur avec et sans)
* \li disperser : il faut disperser tous les élèves notés disperser (prioritaire sur avec et sans)
*/
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"> 
<head>
<meta http-equiv="content-type" 
		content="text/html;charset=utf-8" />
	<title>Réglisse saisie des particularités 2</title>
	<meta name="author" content="Billard" />
	<meta name ="keywords" content ="education, distribution of students into several classes" />
	<link rel="stylesheet" type="text/css" href="styles.css" media="screen" />


<!--
	/////////  GPL Licence - Réglisse
	
	Copyright (c) 2011, Michel Billard Sirakawa http://sibylle.ouvaton.org
 
	This file is part of Réglisse.

	Réglisse is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	Date: 15 juin 2011
	Version :Réglisse version 1
	Author : Michel Billard Sirakawa BillardMchl (at) aol (point) com
	Information site : http://sibylle.ouvaton.org
	///////////
	
	-->
<script language ="javascript">
function suite ()
{
	 var obj = document.getElementById("suivre")
	obj.click();
}
</script>
</head>
<!-- Lecture du fichier des éléves-->


</style>
<?PHP
	include ("reglisse.inc");
	/** string nom de la base de données*/
	$base = $_POST['base'];
	/** mot de passe de la base de données*/
	$passe = $_POST['passe'];		
	/** integer effectif*/
	$nb_individus = isset($_POST['nb_individus']) ? $_POST['nb_individus'] : 0;
class MyDB extends SQLite3
	{
		function __construct($base, $passe)
		{
			try 
			{
				$this->open($base, SQLITE3_OPEN_READWRITE, $passe);
			}
			catch (Exception $e)
			{
				$this->open($base, SQLITE3_OPEN_CREATE, $passe);
			}
		}
	}

	/** 
	* objet SQlite
	*/
	$db = new MyDB($base, $passe);

	/** array cas particuliers */
	$tableau_cas = array();
	
	/** array valeurs des couples $id:$nom saisies dans saisir_particularites.php */
	$particuliers = array();
	$particuliers = isset($_POST['particuliers']) ?$_POST['particuliers']: $particuliers;
	
	/** 
	* array tableau des cas indicé par l'identificateur de l'individu tête de cas
	* \details contient l'id, le nom, compatibles, incompatibles, cas
	* \li cas[$id]['compatibles']: array d'id d'individus à rapprocher
	* \li cas[$id]['incompatibles']	:array d'id d'individus à ne pas rapprocher
	* \li cas[$id]['cas'] 0 pas de cas, 1 grouper, 2 disperser
	*/
	$tableau_cas = array();
	foreach( $particuliers as $individu)
	{
		/** 
		* array contenant l'id et le nom 
		* car la valeur saisie, de la forme id:nom, est explosée 
		*/
		
		$tableau_individu = explode (':', $individu);
		$id = $tableau_individu [0];
		$nom = $tableau_individu [1];
		$tableau_cas[$id]['id'] = $id;
		$tableau_cas[$id]['nom'] = $nom;
		
		$val_incomp = array();
		$requete = "select * from `incompatibles` where eleve_id_1 = $id";
		$resultat_incomp = $db->query($requete);
		$nombre_lignes = 0;
		while ($ligne = $resultat_incomp->fetchArray()):
			$id_incomp= $ligne['eleve_id_2'];
			$tableau_cas [$id]['incompatibles'][] = $id_incomp;
			$nombre_lignes ++;
		endwhile;
		if ($nombre_lignes== 0):
					$tableau_cas [$id]['incompatibles'][] = "";
		endif;
		
		$requete = "select * from `compatibles` where eleve_id_1 = $id";
		$resultat = $db->query ($requete);
		$nombre_lignes = 0;
		while ($ligne = $resultat->fetchArray()):
			$id_comp= $ligne['eleve_id_2'];
			$tableau_cas [$id]['compatibles'][] = $id_comp;
			$nombre_lignes ++;
		endwhile;
		if ($nombre_lignes== 0):
					$tableau_cas [$id]['compatibles'][] = "";
		endif;
		
		$requete =" select * from `particuliers` where eleve_id = $id";
		$resultat = $db->query ($requete);
		if ($ligne =$resultat->fetchArray()):
			$tableau_cas [$id]['cas'] = $ligne['eleve_cas'];
		else:
					$tableau_cas [$id]['cas'] = "";
		endif;
		
		}
/** la liste des élèves*/
$resultat = $db->query("select * from `eleves` order by `eleve_nom`");
/** integer position par rapport au haut de page pour pouvoir 
* être incrémenté et converti en chaine $str_top de pourcentage*/
$top =0;

/** s(tr'ing html présentant la liste des élèves*/
$liste_eleves ="<div class = 'ligne_absolue' style = 'left:66%; width:33%;top:24%; height: 65%; font-size:0.75em;overflow:scroll'>";
while ($ligne = $resultat->fetchArray()):
	/** string position par rapport au haut de page*/
	$str_top = $top."%";
	$nom = $ligne['eleve_nom'];
	$prenom = $ligne['eleve_prenom'];	
	$id = $ligne['eleve_id'];
	$liste_eleves .= "<div class= 'ligne_absolue' style ='border:none; top:$str_top'>
	<div class='cellule' style = 'border:none'>$id</div>
		<div class='cellule' style = 'border:none; overflow:scroll'>$nom $prenom</div></div>";
		$top += 5;
endwhile;
$liste_eleves .= "</div>";
/** string $top transformé en chaîne % */
$str_top = $top."%";
$liste_cas = "<form method = 'post' action ='enregistrer_particularites.php'>
<input type = 'hidden' name='nb_individus' value ='$nb_individus'>
<input type = 'hidden' name='base' value ='$base'>
<input type = 'hidden' name='passe' value ='$passe'>
<div class = 'ligne_absolue' style = 'left :0.5%; top: 24%; height:65%; width:65%; overflow:scroll'>";
$top= 0;
$nb_cas=0;
foreach ($tableau_cas as $cas)
	{
		$nb_cas ++;
		$str_top = $top."%";
		$nom_cas = $cas['nom'];
		$liste_cas .= "
		<div></div>
			<div class = 'ligne' style = 'border-style: solid medium black; width:100%'>
				<div class = 'cellule_d' style ='width:10%;border-style:  none solid solid'>$nom_cas</div>";
				$id = $cas['id'];
				$nom_input_1 = "rapprocher[$id][1]";		
				$nom_input_2 = "rapprocher[$id][2]";	
				$nom_input_3 = "rapprocher[$id][3]";	
				$nom_input_4 = "rapprocher[$id][4]";
				$nom_input_5 = "rapprocher[$id][5]";
				$nom_input_6 = "rapprocher[$id][6]";
				$nom_input_7 = "separer[$id][1]";		
				$nom_input_8 = "separer[$id][2]";		
				$nom_input_9 = "separer[$id][3]";		
				$nom_input_10 = "separer[$id][4]";		
				$nom_input_11 = "separer[$id][5]";		
				$nom_input_12 = "separer[$id][6]";		
				$nom_grouper = "grouper[$id]";
				$grouper = $id;
				$disperser = -$id;
				if ($cas['cas'] == 1):
					$checked_g = "ckecked";
					$checked_d = "";
					$checked_s ="";
					$style_g ="style='font-weight:bolder; font-size:1em'";
					$style_d ="style='font-weight:lighter; font-size:1em'";		
					$style_s ="style='font-weight:lighter; font-size:1em'";					
					else:
						if ($cas== 2):
							$checked_d = "ckecked";
							$checked_g = "";
							$checked_s ="";
							$style_d ="style='font-weight:bolder; font-size:1em'";
							$style_g ="style='font-weight:light; font-size:1em'";		
							$style_s ="style='font-weight:light; font-size:1em'";					
						else:
							$checked_d = "";
							$checked_g = "";
							$checked_s ="checked";
							$style_s ="style='font-weight:bolder; font-size:1em'";
							$style_d ="style='font-weight:light; font-size:1em'";		
							$style_g ="style='font-weight:light; font-size:1em'";					
						endif;
				endif;
				$compatibles = array_pad($cas['compatibles'], 5, "");
				$incompatibles = array_pad($cas['incompatibles'], 5, "");

				$liste_cas .= " 
				<div class = 'cellule_d'>".T_RAPPROCHEMENTS_SOUHAITES."
						<input type='hidden' size='4'  name = '$nom_input_1' value = '$id'>
						<input type='text' size='1' name = '$nom_input_2'  value ='{$compatibles[0]}'>
						<input type='text' size='1' name = '$nom_input_3' value ='{$compatibles[1]}'>
						<input type='text' size='1' name = '$nom_input_4'  value ='{$compatibles[2]}'>
						<input type='text' size='1' name = '$nom_input_5'  value ='{$compatibles[3]}'>
						<input type='text' size='1' name = '$nom_input_6'  value ='{$compatibles[4]}'>
				</div>
					<div class = 'cellule_d' style='border-width: thin thick thin thin'>".T_RAPPROCHEMENTS_INDESIRABLES."
						<input type='hidden' size='4'  name = '$nom_input_7' value = '$id'>
						<input type='text' size='1' name = '$nom_input_8'   value ='{$incompatibles[0]}'>
						<input type='text' size='1' name = '$nom_input_9'  value ='{$incompatibles[1]}'>
						<input type='text' size='1' name = '$nom_input_10'  value ='{$incompatibles[2]}'>
						<input type='text' size='1' name = '$nom_input_11'  value ='{$incompatibles[3]}'>
						<input type='text' size='1' name = '$nom_input_12'  value ='{$incompatibles[4]}'>
					</div>
					<div class = 'cellule_d' $style_g>".T_GROUPER."
						<input type='radio' value='1'  $checked_g name='$nom_grouper'>
					</div>
					<div class = 'cellule_d' $style_d>".T_DISPERSER."
						<input type='radio' value='2' $checked_d name='$nom_grouper'>
					</div>
					<div class = 'cellule_d' $style_s>".T_NEUTRE."
							<input type='radio' value='0' $checked_s name='$nom_grouper'>
					</div>						
				</div>";

		$top +=20;
	}
$liste_cas .= "</div>";
	
if ($nb_cas >0):
$chaine = 
	"<div class = 'ligne_absolue' 
		style = 'border:none'>".
		T_TITRE_1."
	</div>
	<div class = 'ligne_absolue' 
		style = 'top:12%; left:0%;border:none'>".
			T_CONSIGNE_PARTICULARITES_2."
	</div>
		
	
	$bas_de_page";
	
print "<body style = 'background-color:lavender'>

$chaine
$liste_eleves
$liste_cas
		<div class = 'ligne_absolue' style= 'top:92%;left:75%;width:45%;border:none'>
				<div class= 'cellule' style = 'border:none'>
				<button type = 'submit' >Enregistrer</button>
				</form>
				</div>
		</div>
		$bas_de_page";
else:
print "<html><head>
 		<body  onload = 'suite ()'>
	 		<form name = 'formulaire' method = 'post'  action ='enregistrer_particularites.php'>
					<input type='text' name ='base' value='$base' />
					<input type='text' name ='passe' value='$passe' / >
					<button id = 'suivre'  type = 'submit' ></button>

					</form></html>";
endif;
?>
</body>
</html>